-- --------------------------------------------------------------------
-- @author: xhj(必填, 创建模块的人员)
-- @editor: (必填, 后续维护以及修改的人员)
-- @description:
--      八天登录活动面板
-- Create: 2020-02-10
-- --------------------------------------------------------------------
ActionEightLoginWindow = ActionEightLoginWindow or BaseClass(BaseView)

function ActionEightLoginWindow:__init()
	self.ctrl = ActionController:getInstance()
	self.model = self.ctrl:getModel()
    self.is_full_screen = true
    self.win_type = WinType.Big  
    self.view_tag = ViewMgrTag.DIALOGUE_TAG  
    self.layout_name = "action/action_eight_login_window"    
    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_action_eight_login","gw_action_eight_login"), type = ResourcesType.plist },
        { path = PathTool.getPlistImgForDownLoad("gw_action_eight_login","gw_action_eight_login_01"), type = ResourcesType.single },
		--{ path = PathTool.getPlistImgForDownLoad("bigbg/action","txt_cn_action_eight_login_title"), type = ResourcesType.single },
    } 

    self.day_list = {}
    self.cur_index = nil
end

function ActionEightLoginWindow:open_callback()
	self.background = self.root_wnd:getChildByName("background")
    if self.background ~= nil then
        self.background:setScale(display.getMaxScale())
    end
    
    self.main_container = self.root_wnd:getChildByName("main_container")
    self:playEnterAnimatianByObj(self.main_container)

	self.bg = self.main_container:getChildByName("bg")
	local bg_res = PathTool.getPlistImgForDownLoad("gw_action_eight_login", "gw_action_eight_login_01", false)
	if not self.bg_load then
		self.bg_load = loadImageTextureFromCDN(self.bg, bg_res, ResourcesType.single, self.bg_load)
	end

	self.close_btn = self.main_container:getChildByName("close_btn")
	self.close_btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()
			self.ctrl:openEightLoginWin(false)
		end
	end)

	self.detail_btn = self.main_container:getChildByName("detail_btn")
	self.detail_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()
			--local id = 113006
			----if self.cur_index then
			----	if self.cur_index <= 2 then
			----		id = 30502
			----	else
			----		id = 10510
			----	end
			----end
			--
			--if id then
			--	HeroController:getInstance():openHeroInfoWindowByBidStar(id, 10)
			--end
			local hero_id = 114002
			local config = Config.ChargeData.data_constant.login_days_new_hero
			if config ~= nil and config.val ~= nil then
				hero_id = config.val
			end
			GW_HeroHandbookDetailController:getInstance():openHeroClipDetailView(hero_id, 5)
		end
	end)
	local label = self.detail_btn:getChildByName("label")
	label:setString(UI_TI18N(40001))
	label:setFontSize(28)
	if label:getContentSize().width > 130 then
		for k=1,15 do
			label:setFontSize(28-k)
			if label:getContentSize().width <= 130 then
				break
			end
		end
	end

	self.days_container = self.main_container:getChildByName("days_container")
	for i=1,8 do
		local day = self.days_container:getChildByName("day"..i)
		local item = EightLoginItem.new()
		item:setData(i)
		day:addChild(item)
		self.day_list[i] = item
		--self.day_list[i].status = 1 --不可领取
		self.day_list[i]:setStatus(1)
		-- 引导需要
		item:setName("guide_day_"..i)
		item:addCallBack(function (sender, event_type)
			if self.day_list[i] then
				if self.day_list[i].status == 2 then --可领取
					local temp_data = self.model:getSevenLoginData()
					if temp_data then
						local target = self:getMinGetDay(temp_data.status_list)
						if target < i then
							message(UI_TI18N(40002))
							return
						end
						self.ctrl:cs21101(i)
						-- 引导需要
						if sender.guide_call_back ~= nil then
							sender.guide_call_back(sender)
						end
					end
				elseif self.day_list[i].status == 3 or self.day_list[i].status == 1 then --已领取或未到天数
					self:selectByIndex(i)
					local day_conf = Config.LoginDaysNewData.data_day[i]
					if day_conf and day_conf.rewards then
						local config = Config.ItemData.data_get_data(day_conf.rewards[1][1])
						if BackPackConst.checkIsEquip(config.type) then
							HeroController:getInstance():openEquipTips(true, config)
						else
							TipsManager:getInstance():showGoodsTips(config)
						end
					end
				end
			end
		end)
	end


    --self.main_panel = self.main_container:getChildByName("main_panel")
    --self.container = self.main_panel:getChildByName("container")
    --self.close_btn = self.main_panel:getChildByName("close_btn")
	--
    --self.model_icon = self.main_panel:getChildByName("model_icon")
    --
	--self.title_2 = self.main_panel:getChildByName("title_2")
	--
    --self.btn = self.container:getChildByName("btn")
	--self.btn:setTitleText(TI18N("查看详情"))
	--self.btn:setVisible(false)
    --self.day_label = self.container:getChildByName("day_label")
    --self.day_label:setLocalZOrder(21)
	--
    --self.seven_con = self.container:getChildByName("seven_con")
	--
    --for i=1,8 do
    --	local day = self.seven_con:getChildByName("day"..i)
	--	local item = EightLoginItem.new()
	--	item:setData(i)
    --	day:addChild(item)
    --	self.day_list[i] = item
    --	--self.day_list[i].status = 1 --不可领取
	--	self.day_list[i]:setStatus(1)
	--	item:addCallBack(function (  )
	--		if self.day_list[i] then
	--			if self.day_list[i].status == 2 then --可领取
	--				local temp_data = self.model:getSevenLoginData()
	--				if temp_data then
	--					local target = self:getMinGetDay(temp_data.status_list)
	--					if target < i then
	--						message(TI18N("请先领取前一档奖励"))
	--						return
	--					end
	--					self.ctrl:cs21101(i)
	--				end
	--			elseif self.day_list[i].status == 3 or self.day_list[i].status == 1 then --已领取或未到天数
	--				self:selectByIndex(i)
	--				local day_conf = Config.LoginDaysNewData.data_day[i]
	--				if day_conf and day_conf.rewards then
	--					local config = Config.ItemData.data_get_data(day_conf.rewards[1][1])
	--					if BackPackConst.checkIsEquip(config.type) then
	--						HeroController:getInstance():openEquipTips(true, config)
	--					else
	--						TipsManager:getInstance():showGoodsTips(config)
	--					end
	--				end
	--			end
	--		end
    --	end)
    --end


    --self:selectByIndex(1)

    self.ctrl:cs21100()
end

function ActionEightLoginWindow:openRootWnd(  )
	
end

function ActionEightLoginWindow:selectByIndex( index, force )
	if self.cur_index == index and not force then return end
	self.cur_index = index
	--local temp_y = 774
	--local res = PathTool.getTargetRes("bigbg/action","action_eight_bg2",false,false)
	--local res1 = PathTool.getTargetRes("bigbg/action","txt_cn_action_eight_login_title1",false,false)
	--if index <= 2 then
	--	res = PathTool.getTargetRes("bigbg/action","action_eight_bg2",false,false)
	--	res1 = PathTool.getTargetRes("bigbg/action","txt_cn_action_eight_login_title1",false,false)
	--	self.btn:setVisible(true)
	--elseif index == 3 then
	--	res = PathTool.getTargetRes("bigbg/action","action_eight_bg1",false,false)
	--	res1 = PathTool.getTargetRes("bigbg/action","txt_cn_action_eight_login_title2",false,false)
	--	self.btn:setVisible(false)
	--else
	--	temp_y = 783
	--	res = PathTool.getTargetRes("bigbg/action","action_eight_bg3",false,false)
	--	res1 = PathTool.getTargetRes("bigbg/action","txt_cn_action_eight_login_title3",false,false)
	--	self.btn:setVisible(true)
	--end
	--self.model_icon_load = createResourcesLoad(res, ResourcesType.single, function()
	--	if not tolua.isnull(self.model_icon) then
	--		loadSpriteTexture(self.model_icon, res, LOADTEXT_TYPE)
	--	end
	--end,self.model_icon_load)
	--
	--self.title_2_load = createResourcesLoad(res1, ResourcesType.single, function()
	--	if not tolua.isnull(self.title_2) then
	--		loadSpriteTexture(self.title_2, res1, LOADTEXT_TYPE)
	--	end
	--end,self.title_2_load)
	--
	--self.model_icon:setPositionY(temp_y)
	--local day_conf = Config.LoginDaysNewData.data_day[index]
	--if day_conf then
	--	self.day_label:setString(day_conf.reward_desc)
	--end
	
end

function ActionEightLoginWindow:register_event(  )

	--registerButtonEventListener(self.background, function()
	--	self.ctrl:openEightLoginWin(false)
	--end, false,2)
	--
	--registerButtonEventListener(self.close_btn, function()
	--	self.ctrl:openEightLoginWin(false)
	--end, true,2)

	--registerButtonEventListener(self.btn, function()
	--	local id = nil
	--	if self.cur_index then
	--		if self.cur_index <= 2 then
	--			id = 30502
	--		elseif index ~= 3 then
	--			id = 10510
	--		end
	--	end
	--	if id then
	--		HeroController:getInstance():openHeroInfoWindowByBidStar(id, 10)
	--	end
    --end ,true, 1)
	

	--七天登录信息
	if self.update_status == nil then
		self.update_status = GlobalEvent:getInstance():Bind(ActionEvent.UPDATE_SEVEN_LOGIN_STATUS,function ( data )
			if data.status_list then 
				for k,v in pairs(data.status_list) do
					self.day_list[v.day]:setStatus(v.status)
				end
				self.now_day = math.min(#data.status_list + 1,8)
				local target = self:getMinGetDay(data.status_list)
				self:selectByIndex(target, true)
			end
		end)
	end

	--领取成功
	if self.get_event == nil then 
		self.get_event = GlobalEvent:getInstance():Bind(ActionEvent.UPDATE_SEVEN_LOGIN_REWARDS,function ( data )
			-- if data.day < 7 then 
			-- 	self:selectByIndex(data.day+1)
			-- else
			-- 	self:selectByIndex(7)
			-- end
		end)
	end
end

--最小可领取天数
function ActionEightLoginWindow:getMinGetDay( data )
	local day = self.now_day
	for k,v in pairs(data) do
		if v.day == 1 and v.status == 2 then 
			return 1
		else
			if v.day<day and v.status == 2 then 
				day = v.day
			end
		end
	end
	return day
end


function ActionEightLoginWindow:close_callback()

	if self.bg_load then
		self.bg_load:DeleteMe()
		self.bg_load = nil
	end
	--if self.model_icon_load then
    --    self.model_icon_load:DeleteMe()
    --    self.model_icon_load = nil
	--end
	--
	--if self.title_2_load then
    --    self.title_2_load:DeleteMe()
    --    self.title_2_load = nil
    --end

	for k,v in pairs(self.day_list) do
		if v then
			v:DeleteMe()
		end
	end

	self.day_list = nil

	if self.update_status ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_status)
        self.update_status = nil
    end

    if self.get_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.get_event)
        self.get_event = nil
    end

	self.ctrl:openEightLoginWin(false)
end


-- --------------------------------------------------------------------
-- @author: xhj(必填, 创建模块的人员)
-- @editor: (必填, 后续维护以及修改的人员)
-- @description:
--      八天登录活动单个
-- Create: 2020-02-10
-- --------------------------------------------------------------------
EightLoginItem = class("EightLoginItem", function()
    return ccui.Widget:create()
end)

function EightLoginItem:ctor()
	self.ctrl = ActionController:getInstance()
	self.model = self.ctrl:getModel()

	self:configUI()
	self:register_event()
	self.status = 1
	self.day_index = 1
end

function EightLoginItem:configUI(  )
	self.root_wnd = createCSBNote(PathTool.getTargetCSB("action/action_eight_login_item"))
    self:addChild(self.root_wnd)
    self:setCascadeOpacityEnabled(true)
    self:setContentSize(cc.size(124,446))
    self:setAnchorPoint(0,0)

    self.main_container = self.root_wnd:getChildByName("main_container")
    self.main_container:setTouchEnabled(true)
    self.main_container:setSwallowTouches(false)

	self.bg = self.main_container:getChildByName("bg")
	self.day_icon = self.main_container:getChildByName("day_icon")
	self.item_node = self.main_container:getChildByName("item_node")
	self.goods_item = GW_GoodsItem3.new(true,true)
	self.goods_item:setDefaultTip(true)
	self.goods_item:setScale(1)
	self.goods_item:setAnchorPoint(0.5,0.5)
	self.goods_item:setPosition(0,0)
	self.goods_item:setTouchEnabled(false)
	self.goods_item:setSwallowTouches(false)
	self.item_node:addChild(self.goods_item)
	self.locked_label = self.main_container:getChildByName("locked_label")
	self.locked_label:setVisible(false)
	self.locked_label:setString(UI_TI18N(40003))
	self.can_get_label = self.main_container:getChildByName("can_get_label")
	self.can_get_label:setVisible(false)
	self.can_get_label:setString(UI_TI18N(40004))
	self.getted_label = self.main_container:getChildByName("getted_label")
	self.getted_label:setVisible(false)
	self.getted_label:setString(UI_TI18N(40005))
	self.less_time_label = self.main_container:getChildByName("less_time_label")
	self.less_time_label:setVisible(false)
	self.can_get_item_cover = self.main_container:getChildByName("can_get_item_cover")
	self.can_get_item_cover:setVisible(false)

    --self.title = self.main_container:getChildByName("title")
	--self.title:setLocalZOrder(21)
	--self.title_bg = self.main_container:getChildByName("title_bg")
	--self.title_bg:setLocalZOrder(22)
	--self.title_day = self.main_container:getChildByName("title_day")
	--self.title_day:setLocalZOrder(23)
    --self.get = self.main_container:getChildByName("get")
	--self.get:setVisible(false)
	---- PathTool.getEffectRes(292)
	--self.effect = createEffectSpine("E31336",cc.p(self.main_container:getContentSize().width/2, self.main_container:getContentSize().height/2+8),cc.p(0.5, 0.5),true,"action")
	--self.effect:setVisible(false)
	--self.main_container:addChild(self.effect,20)
    --self.icon = self.main_container:getChildByName("icon")
end

function EightLoginItem:register_event(  )
	self.main_container:addTouchEventListener(function(sender, event_type) 
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()
			if self.callback then
				self:callback(sender, event_type)
			end
		end
	end)
end

function EightLoginItem:setData( index )
	if index == 1 then
		self.main_container:setName("get_btn")
	end
	self.day_index = index

	local day_conf = Config.LoginDaysNewData.data_day[index]
	if day_conf == nil then
		Debug.error("找不到八天登陆配置！！Day："..index)
		return
	end
	if day_conf.rewards ~= nil and next(day_conf.rewards) ~= nil and day_conf.rewards[1] ~= nil and #day_conf.rewards[1] >= 2 then
		local bid = day_conf.rewards[1][1]
		local num = day_conf.rewards[1][2]
		self.goods_item:setBaseData(bid, num)
		self.goods_item:setVisible(true)
	else
		self.goods_item:setVisible(false)
	end

	local day_icon = PathTool.getResFrame("gw_action_eight_login", string.format("gw_action_eight_login_%02d", index+7))
	loadSpriteTexture(self.day_icon, day_icon, LOADTEXT_TYPE_PLIST)

    --if day_conf and day_conf.is_spe_day==1 then
	--	if self.effect2 == nil then
	--		-- PathTool.getEffectRes(291)
    --		self.effect2 = createEffectSpine("E31335",cc.p(self.main_container:getContentSize().width/2, self.main_container:getContentSize().height/2),cc.p(0.5, 0.5),true,"action")
    --		self.main_container:addChild(self.effect2,19)
    --	end
    --	if self.effect2 then
    --		self.effect2:setVisible(true)
	--	end
	--	loadSpriteTexture(self.icon, PathTool.getResFrame("actioneightlogin","action_eight_item_"..index), LOADTEXT_TYPE_PLIST)
	--	self.icon:setScale(1)
    --else
    --	if self.effect2 then
    --		self.effect2:setVisible(false)
	--	end
	--	if day_conf and day_conf.rewards[1][1] then
	--		local head_icon = PathTool.getItemRes(day_conf.rewards[1][1], false)
	--		loadSpriteTexture(self.icon, head_icon, LOADTEXT_TYPE)
	--	end
	--	self.icon:setScale(0.8)
	--end
	--if day_conf then
	--	self.title:setString(day_conf.desc)
	--end
	
end

function EightLoginItem:setTitleLab(status)
	--self.title_bg:setContentSize(cc.size(61.69,23))
	local data = self.model:getSevenLoginData()
	if data then
		local len = #data.status_list or 1
		if status == 3 or status == 2 then
			self.less_time_label:setVisible(false)
			doStopAllActions(self.less_time_label)
			--self.title_day:setString(TI18N("第")..self.day_index..TI18N("天"))
		elseif len+2 <= self.day_index then
			self.less_time_label:setVisible(false)
			doStopAllActions(self.less_time_label)
			--self.title_day:setString((self.day_index - len)..TI18N("天后"))
		else
			self.less_time_label:setVisible(true)
			--self.title_bg:setContentSize(cc.size(81.69,23))
			commonCountDownTime(self.less_time_label, TimeTool.getOneDayLessTime())
		end
	end

end


function EightLoginItem:setStatus(status)
	self.status = status
	--if self.status == 3 then --已领取
	--	-- if self.effect2 and not tolua.isnull(self.effect2) then
	--	-- 	self.effect2:setVisible(false)
	--	-- end
	--	if self.effect and not tolua.isnull(self.effect) then
	--		self.effect:setVisible(false)
	--	end
	--	self.get:setVisible(true)
	--else
	--	self.get:setVisible(false)
	--end
	--if self.status == 2 then --可领取
	--	if self.effect and not tolua.isnull(self.effect) then
	--		self.effect:setVisible(true)
	--	end
	--	self.title:setString(TI18N("可领取"))
	--else
	--	if self.effect and not tolua.isnull(self.effect) then
	--		self.effect:setVisible(false)
	--	end
	--	local day_conf = Config.LoginDaysNewData.data_day[self.day_index]
	--	if day_conf then
	--		self.title:setString(day_conf.desc)
	--	end
	--
	--end

	local bg_res_name
	if self.status == 3 then--已领取
		bg_res_name = "gw_action_eight_login_05"
		self.locked_label:setVisible(false)
		self.can_get_label:setVisible(false)
		self.getted_label:setVisible(true)
		self.can_get_item_cover:setVisible(false)
	elseif self.status == 2 then--可领取
		bg_res_name = "gw_action_eight_login_06"
		self.locked_label:setVisible(false)
		self.can_get_label:setVisible(true)
		self.getted_label:setVisible(false)
		self.can_get_item_cover:setVisible(true)
	else--未开启
		bg_res_name = "gw_action_eight_login_07"
		self.locked_label:setVisible(true)
		self.can_get_label:setVisible(false)
		self.getted_label:setVisible(false)
		self.can_get_item_cover:setVisible(false)
	end
	local bg_res = PathTool.getResFrame("gw_action_eight_login", bg_res_name)
	loadSpriteTexture(self.bg, bg_res, LOADTEXT_TYPE_PLIST)

	self:setTitleLab(status)
	-- if self.status == 2 then --可领取
	-- 	if self.effct == nil then
	-- 		self.effect = createEffectSpine(PathTool.getEffectRes(257),cc.p(self.main_container:getContentSize().width/2, self.main_container:getContentSize().height/2),cc.p(0.5, 0.5),true,"action")
    -- 		self.main_container:addChild(self.effect,20)
	-- 	end
	-- 	self.effect:setVisible(true)
	-- else
	-- 	if self.effect then
	-- 		self.effect:setVisible(false)
	-- 	end
	-- end
end


function EightLoginItem:addCallBack( value )
	self.callback =  value
end

function EightLoginItem:DeleteMe()
	doStopAllActions(self.title_day)

	--if self.effect then
    --    self.effect:clearTracks()
    --    self.effect:removeFromParent()
    --    self.effect = nil
	--end
	--
	--if self.effect2 then
    --    self.effect2:clearTracks()
    --    self.effect2:removeFromParent()
    --    self.effect2 = nil
    --end
	 if self.goods_item then
	 	self.goods_item:DeleteMe()
	 	self.goods_item = nil
	 end
end