--------------------------------------------
-- @Author  :
-- @Editor  : lwc
-- @Date    : 2018-11-24 14:42:13
-- @description    : 
		-- 阵营详细
---------------------------------
BattleCampView = BattleCampView or BaseClass(BaseView)

local controller = BattleController:getInstance()
local _table_insert = table.insert
local _string_format = string.format

function BattleCampView:__init()
    self.is_full_screen = false
	self.win_type = WinType.Tips   
    self.view_tag = ViewMgrTag.DIALOGUE_TAG
	self.layout_name = "battle/battle_camp_view"
	self.res_list = {
		{path = PathTool.getPlistImgForDownLoad("gw_endlesstrail", "gw_endlesstrail"), type = ResourcesType.plist},
		{path = PathTool.getPlistImgForDownLoad("gw_embattle", "gw_embattle"), type = ResourcesType.plist},
	}
end

function BattleCampView:open_callback(  )
	self.background = self.root_wnd:getChildByName("background")
	if self.background then
		self.background:setScale(display.getMaxScale())
	end

	local main_container = self.root_wnd:getChildByName("main_container")
	self.main_container = main_container
	--引导需要
	if not GuideController:getInstance():isInGuide() then
		--播放窗口动画
		self:playEnterAnimatianByObj(main_container, 2)
	end
	self.main_size = main_container:getContentSize()

	main_container:getChildByName("title"):setString(UI_TI18N(32013))
	self.close_btn = main_container:getChildByName("close_btn")
	self.close_btn:addTouchEventListener(function(sender, event_type)
		customClickAction(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()
			self:_onClickBtnClose()
		end
	end)
	main_container:getChildByName("left_label"):setString(UI_TI18N(32014))
	main_container:getChildByName("right_label"):setString(UI_TI18N(32015))
	local label = main_container:getChildByName("left_bg"):getChildByName("label")
	label:setString(UI_TI18N(32016))
	label:setFontSize(26)
	if label:getContentSize().width > 160 then
		for k=1,15 do
			label:setFontSize(26-k)
			if label:getContentSize().width <= 160 then
				break
			end
		end
	end

	self.left_attr_list = {}
	for i=1,2 do
		self.left_attr_list[i] = main_container:getChildByName("left_attr"..i)
		self.left_attr_list[i].icon = self.left_attr_list[i]:getChildByName("icon")
		self.left_attr_list[i].label = self.left_attr_list[i]:getChildByName("label")
	end
	PathTool.gw_setAttrIcon(self.left_attr_list[1].icon, "dam")
	self.left_attr_list[1].label:setString(UI_TI18N(32017))
	self.left_attr_list[1].label:setColor(gw_attr_color("dam"))
	PathTool.gw_setAttrIcon(self.left_attr_list[2].icon, "hit_rate")
	self.left_attr_list[2].label:setString(UI_TI18N(32018))
	self.left_attr_list[2].label:setColor(gw_attr_color("hit_rate"))

	self.right_attr_list = {}
	for i=1,3 do
		self.right_attr_list[i] = main_container:getChildByName("right_attr"..i)
		self.right_attr_list[i].icon = self.right_attr_list[i]:getChildByName("icon")
		self.right_attr_list[i].label = self.right_attr_list[i]:getChildByName("label")
		self.right_attr_list[i]:setVisible(false)
	end

	--local title_label_1 = main_container:getChildByName("title_label_1")
	--title_label_1:setString(TI18N("元素克制"))
	--local title_label_2 = main_container:getChildByName("title_label_2")
	--title_label_2:setString(TI18N("元素克制效果:"))
	--local attr_label_1 = main_container:getChildByName("attr_label_1")
	--attr_label_1:setString(TI18N("伤害+25%"))
	--local attr_label_2 = main_container:getChildByName("attr_label_2")
	--attr_label_2:setString(TI18N("命中+20%"))

	self.list_container = main_container:getChildByName("list_container")
	self.list_container:setScrollBarEnabled(false)
	self.list_container:setVisible(false)
	self.list_container_size = self.list_container:getContentSize()

	--local list_panel = main_container:getChildByName("list_container")
	--local bgSize = list_panel:getContentSize()
	--local scroll_view_size = cc.size(bgSize.width, bgSize.height)
    --local setting = {
    --    -- item_class = BattleCampItem,      -- 单元类
    --    start_x = 36,                  -- 第一个单元的X起点
    --    space_x = 0,                    -- x方向的间隔
    --    start_y = 0,                    -- 第一个单元的Y起点
    --    space_y = 9,                   -- y方向的间隔
    --    item_width = 586,               -- 单元的尺寸width
    --    item_height = 278,              -- 单元的尺寸height
    --    row = 0,                        -- 行数，作用于水平滚动类型
    --    col = 1,                         -- 列数，作用于垂直滚动类型
    --    need_dynamic = true
    --}
	--
    --self.camp_scrollview = CommonScrollViewSingleLayout.new(list_panel, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, scroll_view_size, setting)
    ---- self.camp_scrollview:setSwallowTouches(false)
    --self.camp_scrollview:registerScriptHandlerSingle(handler(self,self.createNewCell), ScrollViewFuncType.CreateNewCell) --创建cell
    --self.camp_scrollview:registerScriptHandlerSingle(handler(self,self.numberOfCells), ScrollViewFuncType.NumberOfCells) --获取数量
    --self.camp_scrollview:registerScriptHandlerSingle(handler(self,self.updateCellByIndex), ScrollViewFuncType.UpdateCellByIndex) --更新cell
end

--创建cell 
--@width 是setting.item_width
--@height 是setting.item_height
function BattleCampView:createNewCell(width, height)
    local cell = BattleCampItem.new(width, height)
    -- cell:addCallBack(function() self:onCellTouched(cell) end)
    return cell
end
--获取数据数量
function BattleCampView:numberOfCells()
    return #self.show_list
end

--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--inde :数据的索引
function BattleCampView:updateCellByIndex(cell, index)
    cell.index = index
    local data = self.show_list[index]
    cell:setData(data, index)
end

function BattleCampView:openRootWnd( form_id_list )
	self.form_id_list = form_id_list or {}
	self.form_pos_info = {}
	for k,form_id in pairs(self.form_id_list) do
		local form_cfg = Config.CombatHaloData.data_halo[form_id]
		if form_cfg then
			for _,v in pairs(form_cfg.pos_info) do
				local camp_type = v[1]
				local camp_num = v[2]
				if not self.form_pos_info[camp_type] then
					self.form_pos_info[camp_type] = camp_num
				else
					self.form_pos_info[camp_type] = self.form_pos_info[camp_type] + camp_num
				end
			end
		end
	end
	self:updateAllAttrText()
	self:refreshCampList()
end

-- 全部加成提示
function BattleCampView:updateAllAttrText(  )
	for i,v in pairs(self.right_attr_list) do
		v:setVisible(false)
	end

	--if not self.all_attr_txt then
	--	self.all_attr_txt = createRichLabel(22, cc.c4b(255,125,39,255), cc.p(0.5, 0.5), cc.p(self.main_size.width*0.5, 435), nil, nil, self.main_size.width)
	--	self.main_container:addChild(self.all_attr_txt)
	--end
	local attr_list = {}
	for k,form_id in pairs(self.form_id_list) do
		local form_cfg = Config.CombatHaloData.data_halo[form_id]
		if form_cfg and form_cfg.attrs and next(form_cfg.attrs) ~= nil then
			for _,v in pairs(form_cfg.attrs) do
				local is_have = false
				for _,attr in pairs(attr_list) do
					if attr[1] == v[1] then
						is_have = true
						attr[2] = attr[2] + v[2]
						break
					end
				end
				if not is_have then
					_table_insert(attr_list, deepCopy(v))
				end
			end
		end
	end
	if next(attr_list) == nil then
		--self.all_attr_txt:setString(TI18N("未激活阵营光环"))
	else
		local attr_str = ""
		for i,v in ipairs(attr_list) do
			if i > #self.right_attr_list then
				break
			end

			local attr_key = v[1]
			local attr_val = v[2]/1000
    		--local attr_name = Config.AttrData.data_key_to_name[attr_key]
			local item = self.right_attr_list[i]
			PathTool.gw_setAttrIcon(item.icon, attr_key)
			local is_per = PartnerCalculate.isShowPerByStr(attr_key)
			if is_per == true then
				attr_val = (attr_val*100).."%"
			end
			item.label:setString(string.format("+%s", attr_val))
			item.label:setColor(gw_attr_color(attr_key))
			item:setVisible(true)
    		--if attr_name then
    		--	local is_per = PartnerCalculate.isShowPerByStr(attr_key)
	        --    if is_per == true then
	        --        attr_val = (attr_val*100).."%"
	        --    end
			--
	        --    if i == 1 then
	        --    	attr_str = attr_str .. _string_format("%s<div fontcolor=#68c74b>+%s</div>", attr_name, attr_val)
	        --    else
	        --    	attr_str = attr_str .. _string_format("  %s<div fontcolor=#68c74b>+%s</div>", attr_name, attr_val)
	        --    end
    		--end
		end
		--self.all_attr_txt:setString(TI18N("总加成效果:") .. attr_str)
	end
end

function BattleCampView:checkIsActivateCamp( pos_info )
	local is_activate = false
	if pos_info and next(pos_info) ~= nil then
		is_activate = true
		for _,v in pairs(pos_info) do
			local camp_type = v[1]
			local camp_num = v[2]
			local have_num = 0
			for _type,num in pairs(self.form_pos_info) do
				if _type == camp_type then
					have_num = num
					break
				end
			end
			if camp_num > have_num then
				is_activate = false
				break
			end
		end
	end
	return is_activate
end

function BattleCampView:refreshCampList(  )
	local camp_show_config = Config.CombatHaloData.data_halo_show
	if camp_show_config then
		local camp_data = {}
		local all_activate_id = 7  --记录id 7是 融合之力的
		local is_all_activate = false --记录是否激活了 id 7的
		for id,v in pairs(camp_show_config) do
			local data = deepCopy(v)
			local show_cfg = {}
			show_cfg.id = id
			show_cfg.is_activate = false
			for _,cfg in pairs(data) do
				cfg.is_activate = self:checkIsActivateCamp(cfg.pos_info)
				if cfg.is_activate then
					show_cfg.is_activate = true
					if show_cfg.id == all_activate_id then
						is_all_activate = true
					end
				end
				if not show_cfg.name then
					show_cfg.name = cfg.name
				end
				if not show_cfg.icon then
					show_cfg.icon = cfg.icon
				end
			end
			show_cfg.attr_data = data
			table.insert(camp_data, show_cfg)
		end
		--是否已经触发了融合之力的
		if is_all_activate then
			for i,v in ipairs(camp_data) do
				if v.id ~= all_activate_id then --那么除了融合之力的 其他都不能激活
					v.is_activate = false
				end
			end
		end
		local function SortFunc( objA, objB )
			if objA.is_activate and not objB.is_activate then
				return true
			elseif not objA.is_activate and objB.is_activate then
				return false
			else
				return objA.id < objB.id
			end
		end
		table.sort(camp_data, SortFunc)
		self.show_list = camp_data
		-- self.camp_scrollview:setData(camp_data)
		--self.camp_scrollview:reloadData()
		if self.camp_list == nil then
			self.camp_list = {}
		end
		for i,v in pairs(self.camp_list) do
			v:setVisible(false)
		end
		local item_list_height = 0
		for i,v in pairs(self.show_list) do
			local item = self.camp_list[i]
			if item == nil then
				item = BattleCampItem.new(586, 174)
				item:setPositionX(36)
				self.list_container:addChild(item)
				self.camp_list[i] = item
			end

			item:setData(v, i)
			item_list_height = item.size.height + 9 + item_list_height
		end

		local max_height = math.max(item_list_height + 10, self.list_container_size.height)
		self.list_container:setInnerContainerSize(cc.size(self.list_container_size.width,max_height))
		for i,v in pairs(self.show_list) do
			local item = self.camp_list[i]
			item:setPositionY(max_height)

			max_height = max_height - item.size.height - 9
			item:setVisible(true)
		end

		self.list_container:jumpToTop()
		self.list_container:setVisible(true)
	else
		self.list_container:setVisible(false)
	end
end

function BattleCampView:register_event(  )
	--registerButtonEventListener(self.background, handler(self, self._onClickBtnClose), false, 2)

	-- 战斗结束时关闭界面
	self:addGlobalEvent(SceneEvent.EXIT_FIGHT, function (  )
		controller:openBattleCampView(false)
	end)
end

function BattleCampView:_onClickBtnClose(  )
	controller:openBattleCampView(false)
end

function BattleCampView:close_callback(  )
	--if self.camp_scrollview then
	--	self.camp_scrollview:DeleteMe()
	--	self.camp_scrollview = nil
	--end
	controller:openBattleCampView(false)
end


--------------------------@ item
BattleCampItem = class("BattleCampItem", function()
    return ccui.Widget:create()
end)

function BattleCampItem:ctor(width, height)
	self:configUI(width, height)
	self:register_event()
end

function BattleCampItem:configUI(width, height)
	--self.size = cc.size(width, height)
	--self:setTouchEnabled(false)
    --self:setContentSize(self.size)

	local csbPath = PathTool.getTargetCSB("battle/battle_camp_item")
    self.root_wnd = cc.CSLoader:createNode(csbPath)
	self.size = self.root_wnd:getContentSize()
	self:setTouchEnabled(false)
	self:setContentSize(self.size)
	self:setAnchorPoint(cc.p(0, 1))
    self:addChild(self.root_wnd)

    local container = self.root_wnd:getChildByName("main_container")
    self.container = container

	self.bg = container:getChildByName("bg")
	self.camp_type = container:getChildByName("camp_type")
	self.name_bg = container:getChildByName("name_bg")
	self.name = container:getChildByName("name")
	self.type_list = {}
	for i=1,6 do
		self.type_list[i] = container:getChildByName("type"..i)
		self.type_list[i]:setVisible(false)
		self.type_list[i].camp_type = self.type_list[i]:getChildByName("camp_type")
		self.type_list[i].camp_num = createRichLabel(18, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(0, 0), -5, nil, 96)
		self.type_list[i]:getChildByName("num_node"):addChild(self.type_list[i].camp_num)
		self.type_list[i].attr_list = {}
		for j=1,3 do
			self.type_list[i].attr_list[j] = self.type_list[i]:getChildByName("attr"..j)
			self.type_list[i].attr_list[j]:setVisible(false)
			self.type_list[i].attr_list[j].icon = self.type_list[i].attr_list[j]:getChildByName("icon")
			self.type_list[i].attr_list[j].label = self.type_list[i].attr_list[j]:getChildByName("label")
		end
	end
	self.sp_activate = container:getChildByName("sp_activate")
	self.sp_activate:getChildByName("label"):setString(UI_TI18N(32019))
	self.sp_activate:setVisible(false)

    --self.cur_bg = container:getChildByName("cur_bg")
    --self.cur_bg:setVisible(false)
    --self.form_icon = container:getChildByName("form_icon")
    --self.name = container:getChildByName("name")
    --self.line = container:getChildByName("line")
    --self.sp_activate = container:getChildByName("sp_activate")
    --self.sp_activate:setVisible(false)
	--
    --self.attr_label = createRichLabel(18, 1, cc.p(0, 0.5), cc.p(100, 69), 5, nil, 500)
    --self.container:addChild(self.attr_label)
end

function BattleCampItem:setData( data, index )
	if data then
		-- 是否激活
		if data.is_activate == true then
			--self.cur_bg:setVisible(true)
			self.sp_activate:setVisible(true)
			setChildUnEnabled(false, self.camp_type)
		else
			--self.cur_bg:setVisible(false)
			self.sp_activate:setVisible(false)
			setChildUnEnabled(true, self.camp_type)
		end

		-- 名称
		self.name:setString(data.name)

		if data.id == 4 or data.id == 5 then
			self.name:setPositionY(145)
		else
			self.name:setPositionY(140)
		end

		local type_num = #data.attr_data
		for i,v in pairs(self.type_list) do
			v:setVisible(i<=type_num)
		end

		local height = 174
		if type_num > 3 then
			height = 174 + 52*(type_num - 3)
		end
		self.size = cc.size(586, height)
		self:setContentSize(self.size)
		self.bg:setContentSize(self.size)
		self.camp_type:setPositionY(height-85)
		self.name_bg:setPositionY(height-133)
		self.name:setPositionY(height-136)
		self.sp_activate:setPositionY(height-27)
		for i,v in pairs(self.type_list) do
			v:setPositionY(height - 35 - (i-1)*52)
		end

		local res = PathTool.getResFrame("gw_endlesstrail", data.attr_data[1].icon)
		loadSpriteTexture(self.camp_type, res, LOADTEXT_TYPE_PLIST)
		local index_flag = 0
		for i,v in ipairs(data.attr_data) do
			if v.is_activate and data.is_activate then
				index_flag = i
			end
		end
		for i,v in pairs(data.attr_data) do
			local item = self.type_list[i]
			if item == nil then
				break
			end

			local type_data = data.attr_data[type_num - i + 1]
			local res = PathTool.getResFrame("gw_endlesstrail", type_data.icon2)
			loadSpriteTexture(item.camp_type, res, LOADTEXT_TYPE_PLIST)
			item.camp_num:setString(string.format("<div outline=1,#6e6e6e >%s</div>", type_data.num_icon))
			for j,attr_item in pairs(item.attr_list) do
				attr_item:setVisible(false)
			end
			for j,attr in pairs(type_data.attrs) do
				local attr_item = item.attr_list[j]
				if attr_item == nil then
					break
				end

				local attr_key = attr[1]
				local attr_val = attr[2]/1000
				local is_per = PartnerCalculate.isShowPerByStr(attr_key)
				if is_per == true then
					attr_val = (attr_val*100).."%"
				end

				PathTool.gw_setAttrIcon(attr_item.icon, attr_key)
				attr_item.label:setString(string.format("+%s", attr_val))
				attr_item.label:setColor(gw_attr_color(attr_key))
				attr_item:setVisible(true)
			end

			setChildUnEnabled(index_flag ~= (type_num - i + 1), item)
		end

		---- 图标
		--local form_res = PathTool.getCampGroupIcon(data.icon)
		--self.form_icon_load = loadImageTextureFromCDN(self.form_icon, form_res, ResourcesType.single, self.form_icon_load)
		--
		---- 底线
		--self.line:setVisible(index ~= Config.CombatHaloData.data_halo_show_length)
		--if data.id == 7 then
		--	if self.tip_label == nil then
		--		self.tip_label = createRichLabel(18, cc.c3b(0xff,0xee,0xdd), cc.p(0.5, 0.5), cc.p(self.size.width * 0.5, 35), 5, nil, self.size.width)
		--		self.container:addChild(self.tip_label)
		--		self.tip_label:setString(_string_format(TI18N("（本光环触发时，不同时触发<div fontcolor=#8bff8e>辉光之力</div>和<div fontcolor=#8bff8e>深黯之力</div>）")))
		--	else
		--		self.tip_label:setVisible(true)
		--	end
		--else
		--	if self.tip_label then
		--		self.tip_label:setVisible(false)
		--	end
		--end

		---- 属性
		--local desc_str = ""
		--local index_flag = 0
		--for i,v in ipairs(data.attr_data) do
		--	if v.is_activate and data.is_activate then
		--		index_flag = i
		--	end
		--end
		--for i,v in ipairs(data.attr_data) do
		--	local str = v.desc
		--	for _,attr in ipairs(v.attrs) do
		--		local attr_key = attr[1]
		--		local attr_val = attr[2]/1000
        --		local attr_name = Config.AttrData.data_key_to_name[attr_key]
        --		if attr_name then
        --			local is_per = PartnerCalculate.isShowPerByStr(attr_key)
		--            if is_per == true then
		--                attr_val = (attr_val*100).."%"
		--            end
		--            if i == index_flag then
		--            	str = str .. _string_format("    %s<div fontcolor=#68c74b>+%s</div>", attr_name, attr_val)
		--            else
		--            	str = str .. _string_format("    %s+%s", attr_name, attr_val)
		--            end
        --		end
		--	end
		--	if i == index_flag then
		--		str = _string_format("<div fontcolor=#e0bf98>%s</div>", str)
		--	else
		--		str = _string_format("<div fontcolor=#695b50>%s</div>", str)
		--	end
		--	desc_str = desc_str .. str .. "\n"
		--end
		--self.attr_label:setString(desc_str)

	end
end

function BattleCampItem:register_event(  )
end

function BattleCampItem:DeleteMe(  )
	--if self.form_icon_load then
	--	self.form_icon_load:DeleteMe()
	--	self.form_icon_load = nil
	--end
	self:removeAllChildren()
	self:removeFromParent()
end
