---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/2 9:34
---
GW_ArenaChallengeListWindow = GW_ArenaChallengeListWindow or BaseClass(BaseView)

local controller = ArenaController:getInstance()
local model = ArenaController:getInstance():getModel()

local game_net = GameNet:getInstance()
local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_ArenaChallengeListWindow:__init()
    self.ctrl = GW_ArenaChallengeListController:getInstance()
    self.is_full_screen = false
    self.layout_name = "gw_arena/gw_arena_challenge_list_window"
    self.win_type = WinType.Big
    self.view_tag = ViewMgrTag.DIALOGUE_TAG

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena"), type = ResourcesType.plist},
    }

    self.arena_skip_count = Config.ArenaData.data_const["arena_skip_count"].val --跳过的次数
end

function GW_ArenaChallengeListWindow:openRootWnd()
    controller:sender20208()
    controller:requestChallengeList()

    self:updateInfo()
end

function GW_ArenaChallengeListWindow:open_callback()
    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())

    self.main_container = self.root_wnd:getChildByName("main_container")
    self:playEnterAnimatianByObj(self.main_container, 2)
    self.main_container:getChildByName("title"):setString(UI_TI18N(22031))
    self.close_btn = self.main_container:getChildByName("close_btn")

    self.list_container = self.main_container:getChildByName("list_container")
    self.list_container_size = self.list_container:getContentSize()
    self.pass_battle_label = self.main_container:getChildByName("pass_battle_label")
    self.pass_battle_label:setString(UI_TI18N(22032))
    self.pass_battle_btn = self.main_container:getChildByName("pass_battle_btn")
    self.pass_battle_btn_flag = self.pass_battle_btn:getChildByName("flag")
    self.pass_battle_btn_flag:setVisible(false)

    self.have_challenge_count_info = self.main_container:getChildByName("have_challenge_count_info")
    self.have_challenge_count_info_icon = self.have_challenge_count_info:getChildByName("icon")
    self.have_challenge_count_info_label = self.have_challenge_count_info:getChildByName("label")
    self.have_challenge_count_info_add_btn = self.have_challenge_count_info:getChildByName("add_btn")

    self.refresh_btn = self.main_container:getChildByName("refresh_btn")
    self.refresh_btn_label = self.refresh_btn:getChildByName("label")
    self.refresh_btn_label:setString(UI_TI18N(22033))

    ----背景
    --self.background = self.root_wnd:getChildByName("background")
    --
    --self.container = self.root_wnd:getChildByName("container")
    --
    ----关闭
    --self.btn_close = self.container:getChildByName("btn_close")
    --
    --self.role_item_list = {}
    --for i=1,3 do
    --    self.role_item_list[i] = {}
    --    self.role_item_list[i].root_wnd = self.container:getChildByName(string_format("item%d", i))
    --    self.role_item_list[i].head_node = self.role_item_list[i].root_wnd:getChildByName("head_node")
    --    self.role_item_list[i].role_head = PlayerHead.new(PlayerHead.type.square)
    --    self.role_item_list[i].role_head:setHeadLayerScale(0.75)
    --    self.role_item_list[i].role_head:setPosition(0, 0)
    --    self.role_item_list[i].head_node:addChild(self.role_item_list[i].role_head)
    --    self.role_item_list[i].role_head:addCallBack( function()
    --        if self.role_item_list[i].data ~= nil then
    --            controller:requestLoopChallengeRoleInfo(self.role_item_list[i].data.rid, self.role_item_list[i].data.srv_id)
    --            --FriendController:getInstance():openFriendCheckPanel(true, {srv_id = self.data.srv_id, rid = self.data.rid})
    --        end
    --    end,false)
    --    self.role_item_list[i].name = self.role_item_list[i].root_wnd:getChildByName("name")
    --    self.role_item_list[i].battle = self.role_item_list[i].root_wnd:getChildByName("battle")
    --    self.role_item_list[i].lev = self.role_item_list[i].root_wnd:getChildByName("lev_bg"):getChildByName("lev")
    --    self.role_item_list[i].score = self.role_item_list[i].root_wnd:getChildByName("score_bg"):getChildByName("score")
    --    self.role_item_list[i].challenge_btn = self.role_item_list[i].root_wnd:getChildByName("challenge_btn")
    --    self.role_item_list[i].challenge_btn_label = self.role_item_list[i].challenge_btn:getChildByName("label")
    --    self.role_item_list[i].root_wnd:setVisible(false)
    --    self.role_item_list[i].data = nil
    --
    --    registerButtonEventListener(self.role_item_list[i].challenge_btn, function()
    --        if self.role_item_list[i].data ~= nil then
    --            local status = 0
    --            if model:getJumpFightStatus() == true then
    --                status = 1
    --            end
    --            controller:requestFightWithLoopChallenge(self.role_item_list[i].data.rid, self.role_item_list[i].data.srv_id, status)
    --            self.ctrl:closeView()
    --            --GW_EmbattleController:getInstance():openEmbattleView(PartnerConst.Fun_Form.Drama,{},HeroConst.FormShowType.eFormFight)
    --        end
    --    end,true, 1)
    --end
    --
    --self.text_add_time = self.container:getChildByName("have_challenge_count")
    --self.addtimes_btn = self.container:getChildByName("challenge_count_add_btn")
    --
    --self.refresh_btn = self.container:getChildByName("refresh_btn")
    --self.refresh_label = self.refresh_btn:getChildByName("label")
    --self.refresh_label:setString(TI18N("刷新"))
    --
    --self.btn_jump_fight = self.container:getChildByName("pass_battle_btn")
    --self.check_jump_fight = self.btn_jump_fight:getChildByName("flag")
    --self.check_jump_fight:setVisible(true)
    --
    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.container , 2)
end

function GW_ArenaChallengeListWindow:register_event()
    registerButtonEventListener(self.close_btn, handler(self, self.onClickCloseBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    registerButtonEventListener(self.have_challenge_count_info_add_btn, function()
        controller:openArenaLoopChallengeBuy(true)
    end,true, 1)

    if self.update_challenge_list == nil then
        self.update_challenge_list = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateLoopChallengeList, function()
            self:updateChallengeList()
        end)
    end

    registerButtonEventListener(self.refresh_btn, function()
        controller:requestRefreshChallengeList()
    end,true, 1)

    if self.update_challenge_num == nil then
        self.update_challenge_num = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateArena_Number, function()
            local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
            local item_config = Config.ItemData.data_get_data(id)
            self.has_num = self.has_num or 0
            loadSpriteTexture(self.have_challenge_count_info_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
            self.have_challenge_count_info_label:setString(BackpackController:getInstance():getModel():getBackPackItemNumByBid(id))
        end)
    end

    --跳过战斗
    registerButtonEventListener(self.pass_battle_btn, function()
        if self.cur_combat_num then
            if self.cur_combat_num < self.arena_skip_count then
                self.pass_battle_btn_flag:setVisible(false)
                message(string.format(UI_TI18N(22034),self.arena_skip_count))
            else
                if self.pass_battle_btn_flag:isVisible() == true then
                    self.pass_battle_btn_flag:setVisible(false)
                else
                    self.pass_battle_btn_flag:setVisible(true)
                end
                model:setJumpFightStatus(self.pass_battle_btn_flag:isVisible())
                SysEnv:getInstance():set(SysEnv.keys.gw_arena_skip_fight, self.pass_battle_btn_flag:isVisible(), true)
            end
        end
    end,true, 1)

    if self.update_challenge_time_num == nil then
        self.update_challenge_time_num = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateLoopChallengeTimesList, function(data)
            if not data then return end
            self.cur_combat_num = data.had_combat_num
            if self.cur_combat_num < self.arena_skip_count then
                setChildUnEnabled(true, self.pass_battle_btn)
                self.pass_battle_btn_flag:setVisible(false)
                SysEnv:getInstance():set(SysEnv.keys.gw_arena_skip_fight, self.pass_battle_btn_flag:isVisible(), true)
            else
                setChildUnEnabled(false, self.pass_battle_btn)
                local skip_flag = SysEnv:getInstance():getBool(SysEnv.keys.gw_arena_skip_fight, false)
                self.pass_battle_btn_flag:setVisible(skip_flag)
                model:setJumpFightStatus(self.pass_battle_btn_flag:isVisible())
            end

            --local str = string_format(TI18N("( 挑战%d次 )"),data.had_combat_num)
            --self.box_bar:setPercent(self:segmentBarPercent(data.had_combat_num))
            --
            --self.change_num:setString(str)
            self.had_combat_num = data.had_combat_num
            --for i,v in pairs(box_config) do
            --    self.bool_box_status[i] = 0
            --    if v.num <= data.had_combat_num then
            --        self.bool_box_status[i] = 1
            --        for k,val in pairs(data.num_list) do
            --            if val.num == v.num then
            --                self.bool_box_status[i] = 2
            --            end
            --        end
            --    end
            --end
            --self:updateTaskList(self.bool_box_status)
        end)
    end

    if self.update_my_data == nil then
        self.update_my_data = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateMyLoopData, function(key, value)
            self:updateInfo()
        end)
    end


    -- 增加物品的更新,这里需要判断增加的物品是不是当前标签页类型的,否则不刷新了
    self:addGlobalEvent(BackpackEvent.ADD_GOODS, function(bag_code, add_list)
        self:updateInfo()
    end)
    -- 删除一个物品更新,也需要判断当前标签页类型
    self:addGlobalEvent(BackpackEvent.DELETE_GOODS, function(bag_code,del_list)
        self:updateInfo()
    end)

    self:addGlobalEvent(BackpackEvent.MODIFY_GOODS_NUM, function(bag_code,change_list)
        self:updateInfo()
    end)
end

function GW_ArenaChallengeListWindow:close_callback()
    self:handleEvent(false)

    doStopAllActions(self.container)

    if self.update_challenge_list ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_challenge_list)
        self.update_challenge_list = nil
    end

    if self.update_challenge_num ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_challenge_num)
        self.update_challenge_num = nil
    end

    if self.update_challenge_time_num ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_challenge_time_num)
        self.update_challenge_time_num = nil
    end

    if self.update_my_data ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_my_data)
        self.update_my_data = nil
    end

    if self.scroll_view then
        self.scroll_view:DeleteMe()
        self.scroll_view = nil
    end

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_ArenaChallengeListWindow:__delete()
end

--关闭
function GW_ArenaChallengeListWindow:onClickCloseBtn(force)
    self.ctrl:closeView()
end

function GW_ArenaChallengeListWindow:updateChallengeList()
    local list = model:getLoopChallengeList()
    if list ~= nil and next(list) ~= nil then
        if self.scroll_view == nil then
            --local size = self.list_container:getContentSize()
            local setting = {
                item_class = GW_ArenaLoopChallengeItem,
                start_x = 44,
                space_x = 0,
                start_y = 13,
                space_y = 20,
                item_width = 985,
                item_height = 140,
                row = 1,
                col = 1,
                need_dynamic = true
            }
            self.scroll_view = CommonScrollViewLayout.new(self.list_container, nil, nil, nil, self.list_container_size, setting)
        end

        local tab = {}
        tab.free_num = self.free_num
        tab.has_num = self.has_num
        self.scroll_view:setData(list,nil,nil,tab)
        self.list_container:setVisible(true)
    else
        self.list_container:setVisible(false)
    end
    --for i=1,3 do
    --    self.role_item_list[i].root_wnd:setVisible(false)
    --    self.role_item_list[i].data = nil
    --end
    --
    --local list = model:getLoopChallengeList()
    --if list ~= nil and next(list) ~= nil then
    --    --local tab = {}
    --    --tab.free_num = self.free_num
    --    --tab.has_num = self.has_num
    --
    --    local index = 1
    --    for i, v in pairs(list) do
    --        self.role_item_list[index].data = v
    --        self.role_item_list[index].role_head:setHeadRes(v.face, false, LOADTEXT_TYPE, v.face_file, v.face_update_time)
    --        self.role_item_list[index].name:setString(v.name)
    --        self.role_item_list[index].battle:setString(v.power)
    --        self.role_item_list[index].lev:setString(string_format("Lv.%d", v.lev))
    --        self.role_item_list[index].score:setString(string_format("Lv.%d", v.score))
    --        if self.free_num > 0 then
    --            self.role_item_list[index].challenge_btn_label:setString(TI18N("免费挑战"))
    --        else
    --            self.role_item_list[index].challenge_btn_label:setString(TI18N("1 挑战"))
    --        end
    --
    --        self.role_item_list[index].root_wnd:setVisible(true)
    --
    --        index = index + 1
    --        if index > 3 then
    --            break
    --        end
    --    end
    --end
end

function GW_ArenaChallengeListWindow:handleEvent(status)
    if status == true then
        if self.time_ticket == nil then
            self.time_ticket = GlobalTimeTicket:getInstance():add(function()
                self:countDownTimeTicket()
            end, 1)
        end
        self:countDownTimeTicket()
    else
        if self.time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.time_ticket)
            self.time_ticket = nil
        end
    end
end

function GW_ArenaChallengeListWindow:countDownTimeTicket()
    local data = model:getMyLoopData()
    if data == nil then
        self:handleEvent(false)
        return
    end
    --local less_time = data.end_time - game_net:getTime()
    --if less_time >= 0 then
    --    self.time_label:setString(string_format("%s", TimeTool.GetTimeFormat(less_time)))
    --end

    local refresh = data.ref_time - game_net:getTime()
    if refresh >= 0 then
        self.refresh_btn_label:setString(string_format("%s", TimeTool.GetTimeFormat(refresh)))
    else
        if self.refresh_status == 1 then
            self.refresh_status = 0
            setChildUnEnabled(false, self.refresh_btn)
            self.refresh_btn:setTouchEnabled(true)
            self.refresh_btn_label:enableOutline(cc.c4b(0x0b,0x7e,0xb3,0xff), 2)
            self.refresh_btn_label:setString(UI_TI18N(22033))
        end
    end
end

function GW_ArenaChallengeListWindow:updateInfo()
    local my_data = model:getMyLoopData()
    local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
    local count = BackpackController:getInstance():getModel():getBackPackItemNumByBid(id)
    local num = my_data.can_combat_num + count
    self.has_num = num
    self.free_num = my_data.can_combat_num

    local item_config = Config.ItemData.data_get_data(id)
    if item_config == nil then
        Debug.error("找不到道具配置！！ID:"..id)
    else
        loadSpriteTexture(self.have_challenge_count_info_icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
        self.have_challenge_count_info_label:setString(count)
    end

    -- 不在冷却的时候就直接显示刷新
    local refresh_time = my_data.ref_time - game_net:getTime()
    if refresh_time <= 0 then
        setChildUnEnabled(false, self.refresh_btn)
        self.refresh_btn:setTouchEnabled(true)
        self.refresh_btn_label:enableOutline(cc.c4b(0x0b,0x7e,0xb3,0xff), 2)
        self.refresh_btn_label:setString(UI_TI18N(22033))
        self.refresh_status = 0
    else
        self.refresh_btn_label:setString(string_format("%s", TimeTool.GetTimeFormat(refresh_time)))
        setChildUnEnabled(true, self.refresh_btn)
        self.refresh_btn:setTouchEnabled(false)
        self.refresh_btn_label:disableEffect()
        self.refresh_status = 1
    end

    self:handleEvent(true)
end


-- --------------------------------------------------------------------
-- 挑战赛的单元
-- --------------------------------------------------------------------
GW_ArenaLoopChallengeItem = class("GW_ArenaLoopChallengeItem", function()
    return ccui.Layout:create()
end)

function GW_ArenaLoopChallengeItem:ctor()
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("gw_arena/gw_arena_challenge_list_window_item"))
    self.size = self.root_wnd:getContentSize()
    self:setAnchorPoint(cc.p(0.5, 0.5))
    self:setContentSize(self.size)

    self.root_wnd:setAnchorPoint(0.5, 0.5)
    self.root_wnd:setPosition(self.size.width * 0.5, self.size.height * 0.5)
    self:addChild(self.root_wnd)

    self.battle_node = self.root_wnd:getChildByName("battle_node")
    self.battle_info_spine = gw_createEffectSpine("E90136", cc.p(0, 0), cc.p(0.5, 0.5), true, "animation")
    self.battle_info_spine:setScale(0.70)
    self.battle_info_spine:setPositionY(-7)
    self.battle_node:addChild(self.battle_info_spine)
    self.battle_info_power = CommonNum.new(104, self.battle_node, nil, -18, cc.p(0, 0.5))
    self.battle_info_power:setScale(0.6)
    self.battle_info_power:setPositionX(15)
    self.battle_info_power:setPositionY(12)
    self.battle_info_power:setLocalZOrder(99)
    self.name = self.root_wnd:getChildByName("name")
    self.score_info_label = self.root_wnd:getChildByName("score_info"):getChildByName("label")
    self.head_info = self.root_wnd:getChildByName("head_info")
    self.head_info_lev = self.head_info:getChildByName("lev_bg"):getChildByName("lev_label")
    self.head_node = self.head_info:getChildByName("head_node")
    self.role_head = PlayerHead.new(PlayerHead.type.square, 0)
    self.role_head:setPosition(0, 0)
    self.role_head:setHeadLayerScale(1)
    self.head_node:addChild(self.role_head)
    self.challenge_btn = self.root_wnd:getChildByName("challenge_btn")
    self.challenge_btn_label = createRichLabel(32, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(self.challenge_btn:getContentSize().width*0.5, 33), nil, nil, 230)
    self.challenge_btn:addChild(self.challenge_btn_label)

    --self.container = self.root_wnd:getChildByName("container")
    --self.role_name = self.container:getChildByName("role_name")
    --self.role_name_x = self.role_name:getPositionX()
    --self.role_power = self.container:getChildByName("role_power")
    --self.role_score = self.container:getChildByName("role_score")
    --self.role_score_0 = self.container:getChildByName("role_score_0")
    --self.role_score_0:setString(TI18N("积分:"))
    --self.same_guild = self.container:getChildByName("same_guild")
    --if self.same_guild then
    --    self.same_guild:setString(TI18N("（同公会）"))
    --end
    --
    --self.challenge_btn = self.container:getChildByName("challenge_btn")
    --self.icon = self.challenge_btn:getChildByName("icon")
    --self.icon:setScale(0.4)
    --local item_config = Config.ItemData.data_get_data(Config.ArenaData.data_const.arena_ticketcost.val[1][1])
    --loadSpriteTexture(self.icon, PathTool.getItemRes(item_config.icon), LOADTEXT_TYPE)
    --
    --self.challenge_btn_label = createRichLabel(24, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0.5, 0.5), cc.p(self.challenge_btn:getContentSize().width*0.5, self.challenge_btn:getContentSize().height*0.5), nil, nil, 150)
    --self.challenge_btn:addChild(self.challenge_btn_label)
    --
    --self.finish_img = self.container:getChildByName("finish_img")
    --self.finish_img:setVisible(false)
    --
    --self.role_head = PlayerHead.new(PlayerHead.type.circle)
    --self.role_head:setHeadLayerScale(0.95)
    --self.role_head:setPosition(74, self.size.height * 0.5)
    --self.container:addChild(self.role_head)
    self:registerEvent()
end

function GW_ArenaLoopChallengeItem:registerEvent()
    registerButtonEventListener(self.challenge_btn, function()
        if self.data ~= nil then
            if self.item_free_num < 1 and self.item_has_num < 1 then
                local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
                local back_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(id)
                if back_num < 1 then
                    local config = Config.ItemData.data_get_data(id)
                    if config then
                        BackpackController:getInstance():openTipsSource(true, config)
                    end
                    return
                end
            end

            local status = 0
            if model:getJumpFightStatus() == true then
                status = 1
                controller:requestFightWithLoopChallenge(self.data.rid, self.data.srv_id, status)
            else
                HeroController:getInstance():openFormGoFightPanel(true, PartnerConst.Fun_Form.Drama, {combat_sub_type = BattleConst.Drama_Sub_Type.Arena, combat_rid = self.data.rid, combat_srv_id = self.data.srv_id, combat_status = status}, HeroConst.FormShowType.eFormFight)
            end
            --controller:requestFightWithLoopChallenge(self.data.rid, self.data.srv_id, status)
        end
    end,true, 1)

    self.role_head:addCallBack(function()
        if self.data ~= nil then
            if self.data.score == 0 then
                message(UI_TI18N(22030))
            else
                controller:requestLoopChallengeRoleInfo(self.data.rid, self.data.srv_id)
            end
        end
    end,false)
end

function GW_ArenaLoopChallengeItem:setExtendData(data)
    self.item_has_num = data.has_num
    self.item_free_num = data.free_num
end

function GW_ArenaLoopChallengeItem:setData(data)
    local str = ""
    if self.item_free_num >= 1 then
        str = string_format(UI_TI18N(22035))
    else
        local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
        local back_num = BackpackController:getInstance():getModel():getBackPackItemNumByBid(id)
        local item_config = Config.ItemData.data_get_data(id)
        if item_config == nil then
            Debug.error("找不到道具配置！！ID:"..id)
            if back_num >= 1 then
                str = string_format(UI_TI18N(22036))
            else
                str = string_format(UI_TI18N(22036))
            end
        else
            local res = PathTool.getItemRes(item_config.icon)
            if back_num >= 1 then
                str = string_format(UI_TI18N(22037), res)
            else
                str = string_format(UI_TI18N(22037), res)
            end
        end
    end
    self.challenge_btn_label:setString(str)

    self.data = data
    if self.data ~= nil then
        StringUtil.gw_setRoleNickName(self.name, self.data.name, 250)
        --self.name:setString(self.data.name)
        if self.data.power == 0 then
            self.battle_info_power:setNum(0)
        else
            self.battle_info_power:setNum(self.data.power)
        end
        if self.data.score == 0 then
            self.score_info_label:setString("???")
        else
            self.score_info_label:setString(self.data.score)
        end
        self.role_head:setHeadRes(self.data.face, false, LOADTEXT_TYPE, self.data.face_file, self.data.face_update_time)
        if self.data.lev == 0 then
            self.head_info_lev:setString("??")
        else
            self.head_info_lev:setString(self.data.lev)
        end
        --self.finish_img:setVisible(self.data.status ~= 0)
        self.challenge_btn:setVisible(self.data.status == 0)
        --self:changePowerColor()

        --if self.same_guild then
        --    if role_vo and role_vo.gid and role_vo.gid ~= 0 and self.data.gid and role_vo.gid == self.data.gid then
        --        self.same_guild:setVisible(true)
        --        local size = self.name:getContentSize()
        --        self.same_guild:setPositionX(self.role_name_x + size.width + 5)
        --    else
        --        self.same_guild:setVisible(false)
        --    end
        --end
    end
    -- 引导需要
    self.challenge_btn:setName("challenge_btn_" .. data.idx)
    --self.challenge_btn:setTag(1000+data.idx)
end

function GW_ArenaLoopChallengeItem:changePowerColor()
    --if role_vo == nil then return end
    --if self.data == nil then return end
    --if self.data.power  >  (1.2 * role_vo.power) then -- 需要显示红色
    --    self.role_power:setTextColor(Config.ColorData.data_color4[11])
    --else
    --    self.role_power:setTextColor(Config.ColorData.data_color4[180])
    --end
end

function GW_ArenaLoopChallengeItem:updateSelfInfo(key, value)
    if key == "name" then
        StringUtil.gw_setRoleNickName(self.name, value, 250)
        --self.name:setString(value)
    elseif key == "score" then
        if value == 0 then
            self.score_info_label:setString("???")
        else
            self.score_info_label:setString(value)
        end
    elseif key == "power" then
        if value == 0 then
            self.battle_info_power:setNum(0)
        else
            self.battle_info_power:setNum(value)
        end
        --self:changePowerColor()
    elseif key == "face" then
        self.role_head:setHeadRes(value)
    elseif key == "lev" then
        if value == 0 then
            value = "??"
        end
        self.head_info_lev:setString(value)
    elseif key == "status" then
        --self.finish_img:setVisible(value ~= 0)
        self.challenge_btn:setVisible(value == 0)
    end
end

function GW_ArenaLoopChallengeItem:DeleteMe()
    if self.role_head then
        self.role_head:DeleteMe()
        self.role_head = nil
    end
    if self.battle_info_spine then
        self.battle_info_spine:clearTracks()
        self.battle_info_spine:removeFromParent()
        self.battle_info_spine = nil
    end
    self:removeAllChildren()
    self:removeFromParent()
end