---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/6/29 8:53
---
GW_ArenaHallWindow = GW_ArenaHallWindow or BaseClass(BaseView)

local role_vo = RoleController:getInstance():getRoleVo()

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_ArenaHallWindow:__init()
    self.ctrl = GW_ArenaHallController:getInstance()
    self.is_full_screen = true
    self.layout_name = "gw_arena/gw_arena_hall_window"

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena"), type = ResourcesType.plist},
        --{ path = PathTool.getPlistImgForDownLoad("gw_arena","gw_arena_hall_bg", false), type = ResourcesType.single },
        { path = PathTool.getPlistImgForDownLoad("gw_arena","gw_arena_01_bg_Entrance", true), type = ResourcesType.single },
    }

end

--@sheet_type 竞技大厅页签类型 GW_ArenaHallConst.Sheet_Type
function GW_ArenaHallWindow:openRootWnd(sheet_type, camp_type)
    ExchangeController:getInstance():send23606()
    self.sheet_type = sheet_type or GW_ArenaHallConst.GW_Sheet_Type.Sheet1
    if self.sheet_type == GW_ArenaHallConst.GW_Sheet_Type.Sheet2 then
        self.sheet_type = GW_ArenaHallConst.GW_Sheet_Type.Sheet1
    elseif self.sheet_type == GW_ArenaHallConst.GW_Sheet_Type.Sheet3 then
        if CrossarenaController:getInstance():getModel():getCrossarenaIsOpen(true) == false then
            self.sheet_type = GW_ArenaHallConst.GW_Sheet_Type.Sheet1
        end
    end

    self:setSheetTypeUI()
    self:updateSheet1Redpoint()
    self:updateTopNumWealth()

    ArenaController:getInstance():sender20200()
end

function GW_ArenaHallWindow:open_callback()
    self.left_top_container = self.root_wnd:getChildByName("left_top_container")
    self.left_top_container:setPositionX(display.getLeft())
    self.left_top_container:setPositionY(display.getTop())
    self.right_top_container = self.root_wnd:getChildByName("right_top_container")
    self.right_top_container:setPositionX(display.getRight())
    self.right_top_container:setPositionY(display.getTop())
    self.bottom_container = self.root_wnd:getChildByName("bottom_container")
    self.bottom_container:setPositionY(display.getBottom())
    self.sheet_node = self.bottom_container:getChildByName("sheet_node")
    self.sheet_node:setPositionX(display.getRight())
    self.bottom_bg = self.bottom_container:getChildByName("bg")
    self.bottom_bg:setContentSize(cc.size(display.width, 120))
    self.sheet1_panel = self.root_wnd:getChildByName("sheet1_panel")
    self.sheet1_panel:setVisible(false)
    self.sheet2_panel = self.root_wnd:getChildByName("sheet2_panel")
    self.sheet2_panel:setVisible(false)
    self.sheet3_panel = self.root_wnd:getChildByName("sheet3_panel")
    self.sheet3_panel:setVisible(false)

    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())
    local bg_res = PathTool.getPlistImgForDownLoad("gw_arena", "gw_arena_01_bg_Entrance", true)
    if not self.background_load then
        self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
    end

    --返回上一级
    self.back_btn = self.left_top_container:getChildByName("back_btn")
    self.back_btn:getChildByName("label"):setString(UI_TI18N(10000002))
    self.back_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self.ctrl:closeView()
        end
    end)
    --返回主城
    self.home_btn = self.right_top_container:getChildByName("home_btn")
    self.home_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            BackToHome()
        end
    end)

    --上方资产
    self.top_num_wealth_list = {}
    for i=1,3 do
        self.top_num_wealth_list[i] = {}
        if i==1 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("gold_info")
        elseif i==2 then
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("diamond_info")
        else
            self.top_num_wealth_list[i].btn = self.right_top_container:getChildByName("hero_exp_info")
        end
        self.top_num_wealth_list[i].icon = self.top_num_wealth_list[i].btn:getChildByName("icon")
        self.top_num_wealth_list[i].value = self.top_num_wealth_list[i].btn:getChildByName("label")
    end

    --页签
    local sheet_btn_name_list = {
        [1] = UI_TI18N(22051),
        [2] = UI_TI18N(22053),
        [3] = UI_TI18N(22052)
    }
    self.sheet_btn_list = {}
    for i=1,3 do
        self.sheet_btn_list[i] = self.sheet_node:getChildByName("sheet_btn"..i)
        self.sheet_btn_list[i].normal = self.sheet_btn_list[i]:getChildByName("normal")
        self.sheet_btn_list[i].select = self.sheet_btn_list[i]:getChildByName("select")
        local normal_label = self.sheet_btn_list[i].normal:getChildByName("label")
        local select_label = self.sheet_btn_list[i].select:getChildByName("label")
        normal_label:setString(sheet_btn_name_list[i])
        select_label:setString(sheet_btn_name_list[i])
        normal_label:setFontSize(28)
        select_label:setFontSize(28)
        if normal_label:getContentSize().width > 230 then
            for k=1,10 do
                normal_label:setFontSize(28-k)
                select_label:setFontSize(28-k)
                if normal_label:getContentSize().width <= 230 then
                    break
                end
            end
        end
        self.sheet_btn_list[i].red_point = self.sheet_node:getChildByName("red_point"..i)
        self.sheet_btn_list[i]:addTouchEventListener(function(sender, event_type)
            if event_type == ccui.TouchEventType.ended then
                playButtonSound2()
                self:onClickSheetBtn(i)
            end
        end)
    end
    local spine_node = self.sheet_btn_list[1].select:getChildByName("spine_node")
    function onSheetBtn1SpineCallBack()
        if self.sheet_btn_list[1].spine_flag == true then
            self.sheet_btn_list[1].spine_flag = false
            self.sheet_btn_list[1].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[1].spine_flag = false
    self.sheet_btn_list[1].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn1SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[1].spine)
    local spine_node = self.sheet_btn_list[2].select:getChildByName("spine_node")
    function onSheetBtn2SpineCallBack()
        if self.sheet_btn_list[2].spine_flag == true then
            self.sheet_btn_list[2].spine_flag = false
            self.sheet_btn_list[2].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[2].spine_flag = false
    self.sheet_btn_list[2].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn2SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[2].spine)
    local spine_node = self.sheet_btn_list[3].select:getChildByName("spine_node")
    function onSheetBtn3SpineCallBack()
        if self.sheet_btn_list[3].spine_flag == true then
            self.sheet_btn_list[3].spine_flag = false
            self.sheet_btn_list[3].spine:setAnimation(0, "anniu_xunhuan", true)
        end
    end
    self.sheet_btn_list[3].spine_flag = false
    self.sheet_btn_list[3].spine = gw_createEffectSpine("E90100", cc.p(0, 0), cc.p(0.5, 0.5), false, "anniu_xunhuan", onSheetBtn3SpineCallBack)
    spine_node:addChild(self.sheet_btn_list[3].spine)

    self.coin_redpoint = self.top_num_wealth_list[2].btn:getChildByName("add")

    ----播放窗口动画
    --self:playEnterAnimatianByObj(self.root_wnd , 1)
end

function GW_ArenaHallWindow:register_event()
    if role_vo then
        if self.role_update_event == nil then
            self.role_update_event = role_vo:Bind(RoleEvent.UPDATE_ROLE_ATTRIBUTE, function(key, value)
                if key == "coin" or key == "gold" or key == "red_gold" or key == "silver_coin" or key == "hero_exp" then
                    self:updateTopNumWealth()
                end
                if key == "lev" then
                    self:updateSheet1Panel()
                    self:updateSheet1Redpoint()
                    self:updataExchangeRedPoint()
                end
            end)
        end
    end
    self.top_num_wealth_list[1].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            VipController:getInstance():openVipMainWindow(true, VIPTABCONST.CHARGE)
        end
    end)
    self.top_num_wealth_list[2].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            ExchangeController:getInstance():openExchangeMainView(true)
        end
    end)
    self.top_num_wealth_list[3].btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            local config = Config.ItemData.data_get_data(Config.ItemData.data_assets_label2id.hero_exp)
            if config then
                BackpackController:getInstance():openTipsSource(true, config)
            end
        end
    end)

    if self.update_self_event == nil then
        self.update_self_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateMyLoopData, function()
            self:updateSheet1Panel()
            self:updateSheet1Redpoint()
        end)
    end
    if self.update_arena_red_event == nil then
        self.update_arena_red_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateArenaRedStatus, function(type, status)
            self:updateSheet1Panel()
            self:updateSheet1Redpoint()
        end)
    end
    -- 更新个人信息
    if self.update_role_info_event == nil then
        self.update_role_info_event = GlobalEvent:getInstance():Bind(ArenaEvent.UpdateChampionRoleInfoEvent, function(data)
            self:updateSheet1Panel()
            self:updateSheet1Redpoint()
        end)
    end

    --点金红点
    if self.coin_touch_redpoint == nil then
        self.coin_touch_redpoint = GlobalEvent:getInstance():Bind(ExchangeEvent.Extra_Reward, function(data)
            self.exchange_data = data
            self:updataExchangeRedPoint()
        end)
    end
end

function GW_ArenaHallWindow:close_callback()
    doStopAllActions(self.infos)
    doStopAllActions(self.background)

    self:handleEventSheet1Panel(false)

    if self.sheet1_panel_item_list then
        for i,item in pairs(self.sheet1_panel_item_list) do
            if item.red_point_spine ~= nil then
                item.red_point_spine:setVisible(false)
                item.red_point_spine:removeFromParent()
                item.red_point_spine = nil
            end
        end
        self.sheet1_panel_item_list = nil
    end

    self.sheet_type = nil

    if self.sheet_btn_list then
        for i,sheet in pairs(self.sheet_btn_list) do
            if sheet.red_point_spine ~= nil then
                sheet.red_point_spine:setVisible(false)
                sheet.red_point_spine:removeFromParent()
                sheet.red_point_spine = nil
            end
            if sheet.spine then
                sheet.spine:clearTracks()
                sheet.spine:removeFromParent()
                sheet.spine = nil
            end
        end
        self.sheet_btn_list = nil
    end

    if self.role_update_event then
        GlobalEvent:getInstance():UnBind(self.role_update_event)
        self.role_update_event = nil
    end

    self.top_num_wealth_list = nil

    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end

    if self.update_self_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_self_event)
        self.update_self_event = nil
    end
    if self.update_arena_red_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_arena_red_event)
        self.update_arena_red_event = nil
    end
    if self.update_role_info_event ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_role_info_event)
        self.update_role_info_event = nil
    end


    self.exchange_data = nil
    if self.coin_redpoint_spine ~= nil then
        self.coin_redpoint_spine:clearTracks()
        self.coin_redpoint_spine:removeFromParent()
        self.coin_redpoint_spine = nil
    end
    if self.coin_touch_redpoint then
        GlobalEvent:getInstance():UnBind(self.coin_touch_redpoint)
        self.coin_touch_redpoint = nil
    end

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_ArenaHallWindow:__delete()
end

--刷新上方货币
function GW_ArenaHallWindow:updateTopNumWealth()
    if not self.top_num_wealth_list then return end

    if self.top_num_wealth_list[1] ~= nil then
        local key = "gold"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[1].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[1].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[1].btn:setVisible(true)
    end
    if self.top_num_wealth_list[2] ~= nil then
        local key = "coin"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[2].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[2].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[2].btn:setVisible(true)
    end
    if self.top_num_wealth_list[3] ~= nil then
        local key = "hero_exp"
        local key_value = role_vo[key] or 0
        self.top_num_wealth_list[3].value:setString(MoneyTool.GetMoneyString(key_value))
        local item_id = Config.ItemData.data_assets_label2id[key]
        local config = Config.ItemData.data_get_data(item_id)
        if config then
            local res = PathTool.getItemRes(config.icon, false)
            loadSpriteTexture(self.top_num_wealth_list[3].icon, res, LOADTEXT_TYPE)
        end
        self.top_num_wealth_list[3].btn:setVisible(true)
    end
end

--更新点金红点
function GW_ArenaHallWindow:updataExchangeRedPoint()
    if not self.exchange_data then
        return
    end
    local red_lev_min =  Config.ConvertData.data_trade_cost.red_lev_min
    for i,v in ipairs(self.exchange_data.list) do
        if v.id == 1 and self.coin_redpoint then
            local status = false
            if (v.max - v.num) > 0 and role_vo and red_lev_min and red_lev_min.val <= role_vo.lev then
                status = true
            end
            if status == true then
                if self.coin_redpoint_spine == nil then
                    self.coin_redpoint_spine = PathTool.gw_createRedpointSpine()
                    self.coin_redpoint_spine:setPosition(40,32)
                    self.coin_redpoint:addChild(self.coin_redpoint_spine)
                end
                self.coin_redpoint_spine:setVisible(true)
                break
            else
                if self.coin_redpoint_spine then
                    self.coin_redpoint_spine:setVisible(false)
                end
            end
        end
    end
end

--点击页签
function GW_ArenaHallWindow:onClickSheetBtn(index)
    if self.sheet_type == index then
        return
    end

    if index == GW_ArenaHallConst.GW_Sheet_Type.Sheet3 then
        --星河神殿当前未开启，所以不能点击
        FunctionNotOpenTips()
        return
    elseif index == GW_ArenaHallConst.GW_Sheet_Type.Sheet2 then
        --跨服竞技当前未开启，所以不能点击
        --JumpController:getInstance():jumpViewByEvtData({53})
        if CrossarenaController:getInstance():getModel():getCrossarenaIsOpen(false) == false then
            return
        end

        MainuiController:getInstance():requestOpenBattleRelevanceWindow(BattleConst.Fight_Type.CrossArenaWar)
    end

    self.sheet_type = index

    self:setSheetTypeUI()
end
--根据页签类型刷新页签
function GW_ArenaHallWindow:setSheetTypeUI()
    if self.sheet_type == nil then return end

    for i,v in pairs(self.sheet_btn_list) do
        v.normal:setVisible(true)
        v.select:setVisible(false)
        v.spine_flag = false
    end

    self.sheet_btn_list[self.sheet_type].normal:setVisible(false)
    self.sheet_btn_list[self.sheet_type].select:setVisible(true)

    self.sheet_btn_list[self.sheet_type].spine_flag = true
    self.sheet_btn_list[self.sheet_type].spine:setAnimation(0, "anniu_xuanzhong", false)

    self:updateSheetPanels()
end
function GW_ArenaHallWindow:updateSheetPanels()
    self:updateSheet1Panel()
    self:updateSheet2Panel()
    self:updateSheet3Panel()
end
function GW_ArenaHallWindow:updateSheet1Panel()
    if self.sheet_type == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
        self:handleEventSheet1Panel(false)
        self.sheet1_panel:setVisible(false)
        return
    end

    if self.sheet1_panel_item_list == nil then
        self.sheet1_panel_item_list = {}
        for i=1,3 do
            local item = self.sheet1_panel:getChildByName("item"..i)
            item.click_btn = item:getChildByName("click_btn")
            --引导需要
            item.click_btn:setName("guide_arena_" .. i)
            item.click_btn:addTouchEventListener(function(sender, event_type)
                customClickAction_4(sender, event_type)
                if event_type == ccui.TouchEventType.ended then
                    playButtonSound2()
                    self:onClickSheet1PanelItem(i)
                end
            end)
            item.block_opened = item:getChildByName("block_opened")
            item.block_opened:setVisible(false)
            item.block_closed = item:getChildByName("block_closed")
            item.block_closed:setVisible(false)
            item.name = item.click_btn:getChildByName("name")
            item.time_info_opened = item:getChildByName("time_info_opened")
            item.time_info_opened:setVisible(false)
            item.time_info_opened_label1 = item.time_info_opened:getChildByName("label1")
            item.time_info_opened_label1:setString(UI_TI18N(22054))
            item.time_info_opened_label2 = item.time_info_opened:getChildByName("label2")
            item.time_info_closed = item:getChildByName("time_info_closed")
            item.time_info_closed:setVisible(false)
            item.time_info_closed_label1 = item.time_info_closed:getChildByName("label1")
            item.time_info_closed_label1:setString(UI_TI18N(22054))
            item.time_info_closed_label2 = item.time_info_closed:getChildByName("label2")
            item.rank_info = item.click_btn:getChildByName("rank_info")
            item.rank_info_bg = item.rank_info:getChildByName("bg")
            item.rank_info_label1 = item.rank_info:getChildByName("label1")
            item.rank_info_label1:setString(UI_TI18N(22055))
            local width = item.rank_info_label1:getContentSize().width + 12
            if width > 200 then width = 200 end
            if width < 84 then width = 84 end
            item.rank_info_bg:setContentSize(cc.size(width, 24))
            width = width - 12
            StringUtil.gw_setLabelContent(item.rank_info_label1, nil, width)
            item.rank_info_label2 = item.rank_info:getChildByName("label2")
            item.count_info = item.click_btn:getChildByName("count_info")
            item.count_info_label1 = item.count_info:getChildByName("label1")
            item.count_info_label2 = item.count_info:getChildByName("label2")
            item.red_point = item.click_btn:getChildByName("red_point")
            item.red_point:setVisible(false)

            self.sheet1_panel_item_list[i] = item
        end
    end

    self:handleEventSheet1Panel(true)
    self:updateSheet1PanelItem1()
    self:updateSheet1PanelItem2()
    self:updateSheet1PanelItem3()
    self.sheet1_panel:setVisible(true)
end
function GW_ArenaHallWindow:onClickSheet1PanelItem(index)
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
        return
    end

    if index == 1 then--竞技场
        if role_vo.lev < Config.ArenaData.data_const["limit_lev"].val then
            --等级不足
            message(string.format(UI_TI18N(22001), Config.ArenaData.data_const["limit_lev"].val))
            return
        end
        MainuiController:getInstance():requestOpenBattleRelevanceWindow(BattleConst.Fight_Type.Arena)
    elseif index == 2 then--周冠赛
        local is_open = (Config.ArenaChampionData.data_const.is_open.val == 1)
        if is_open == true then
            --ArenaController:getInstance():openArenaEnterWindow(true, ArenaConst.arena_type.rank)
            ArenaController:getInstance():openArenaChampionMatchWindow(true, ArenaConst.champion_index.match, ArenaConst.champion_type.normal)
        else
            FunctionNotOpenTips()
        end
    elseif index == 3 then
        local is_open = false
        if is_open == true then

        else
            FunctionNotOpenTips()
        end
    end
end
function GW_ArenaHallWindow:updateSheet1PanelItem1()
    if self.sheet_type == nil or self.sheet1_panel_item_list == nil or self.sheet1_panel_item_list[1] == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
        return
    end

    local item = self.sheet1_panel_item_list[1]

    local red_status = false
    StringUtil.gw_setLabelContent(item.name, UI_TI18N(22056), 245)
    if role_vo.lev < Config.ArenaData.data_const["limit_lev"].val then
        local str = StringFormat(UI_TI18N(22057), Config.ArenaData.data_const["limit_lev"].val)
        StringUtil.gw_setLabelContent(item.time_info_closed_label2, str, 160)
        item.rank_info_label2:setString(UI_TI18N(22058))
        item.count_info_label1:setString(UI_TI18N(22059))
        item.count_info_label2:setString("0")
        local width = item.count_info_label1:getContentSize().width + item.count_info_label2:getContentSize().width + 5
        local scale = 1
        if width > 250 then
            scale = 250/width
            width = 250
        end
        item.count_info_label1:setPositionX(132 - (width*scale/2))
        item.count_info_label2:setPositionX(item.count_info_label1:getPositionX() + item.count_info_label1:getContentSize().width*scale + 5*scale)
        item.count_info_label1:setScale(scale)
        item.count_info_label2:setScale(scale)
        item.block_opened:setVisible(false)
        item.block_closed:setVisible(true)
        item.time_info_opened:setVisible(false)
        item.time_info_closed:setVisible(true)
    else
        local rank = 0--排名
        local has_num = 0--可挑战次数（免费次数+挑战券数量）
        local free_num = 0--免费挑战次数
        local less_time = 0--赛季剩余时间
        local data = ArenaController:getInstance():getModel():getMyLoopData()
        if data then
            rank = data.rank--排名
            less_time = data.end_time - GameNet:getInstance():getTime()
            if less_time < 0 then
                less_time = 0
            end
            local id = Config.ArenaData.data_const.arena_ticketcost.val[1][1]
            --local item_config = Config.ItemData.data_get_data(id)
            local count = BackpackController:getInstance():getModel():getBackPackItemNumByBid(id)
            local num = data.can_combat_num + count
            has_num = num--可挑战次数（免费次数+挑战券数量）
            free_num = data.can_combat_num--免费挑战次数
        end

        item.time_info_opened_label2:setString(TimeTool.GetTimeFormat(less_time))
        if rank <= 0 then
            item.rank_info_label2:setString(UI_TI18N(22017))
        else
            item.rank_info_label2:setString(rank)
        end
        item.count_info_label1:setString(UI_TI18N(22059))
        item.count_info_label2:setString(free_num)
        local width = item.count_info_label1:getContentSize().width + item.count_info_label2:getContentSize().width + 5
        local scale = 1
        if width > 240 then
            scale = 240/width
            width = 240
        end
        item.count_info_label1:setPositionX(120 - (width*scale/2))
        item.count_info_label2:setPositionX(item.count_info_label1:getPositionX() + item.count_info_label1:getContentSize().width*scale + 5*scale)
        item.count_info_label1:setScale(scale)
        item.count_info_label2:setScale(scale)

        red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_challenge)
        if red_status == false then
            red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_artivity)
        end
        if red_status == false then
            red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_log)
        end

        item.block_opened:setVisible(true)
        item.block_closed:setVisible(false)
        item.time_info_opened:setVisible(true)
        item.time_info_closed:setVisible(false)
    end

    if red_status == true and item.red_point_spine == nil then
        item.red_point_spine = PathTool.gw_createRedpointSpine()
        item.red_point:addChild(item.red_point_spine)
    end
    item.red_point:setVisible(red_status)
end
function GW_ArenaHallWindow:updateSheet1PanelItem2()
    if self.sheet_type == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
        return
    end

    local is_open = Config.ArenaChampionData.data_const.is_open.val or 2

    local item = self.sheet1_panel_item_list[2]

    local red_status = false
    StringUtil.gw_setLabelContent(item.name, UI_TI18N(22060), 245)
    StringUtil.gw_setLabelContent(item.count_info_label1, UI_TI18N(22061), 250)
    if is_open == 2 then
        StringUtil.gw_setLabelContent(item.time_info_closed_label2, UI_TI18N(22062), 160)
        StringUtil.gw_setLabelContent(item.rank_info_label2, UI_TI18N(22063), 220)
        StringUtil.gw_setLabelContent(item.count_info_label2, UI_TI18N(22064), 250)
        item.block_opened:setVisible(false)
        item.block_closed:setVisible(true)
        item.time_info_opened:setVisible(false)
        item.time_info_closed:setVisible(true)
    else
        local base_info = ArenaController:getInstance():getChampionModel():getBaseInfo()
        if base_info == nil then
            StringUtil.gw_setLabelContent(item.time_info_opened_label2, UI_TI18N(22065), 160)
            StringUtil.gw_setLabelContent(item.rank_info_label2, UI_TI18N(22063), 220)
            StringUtil.gw_setLabelContent(item.count_info_label2, UI_TI18N(22064), 250)
        else

            if base_info.step == ArenaConst.champion_step.score then
                if base_info.step_status ~= ArenaConst.champion_step_status.unopened then
                    red_status = true
                end
            elseif base_info.step == ArenaConst.champion_step.match_32 then
                if base_info.step_status == ArenaConst.champion_step_status.opened then
                    red_status = true
                end
            elseif base_info.step == ArenaConst.champion_step.match_4 then
                if base_info.step_status == ArenaConst.champion_step_status.opened then
                    red_status = true
                end
            end

            --if base_info.round_status == ArenaConst.champion_round_status.guess then
            --    red_status = true
            --end

            local tips_str = ""
            if base_info.step == ArenaConst.champion_step.unopened then
                tips_str = UI_TI18N(22066)
            elseif base_info.step == ArenaConst.champion_step.score then
                if base_info.step_status == ArenaConst.champion_step_status.unopened then
                    tips_str = UI_TI18N(22067)
                else
                    tips_str = UI_TI18N(22068)
                end
            elseif base_info.step == ArenaConst.champion_step.match_32 then
                if base_info.step_status == ArenaConst.champion_step_status.unopened then
                    tips_str = UI_TI18N(22069)
                else
                    tips_str = UI_TI18N(22070)
                end
            elseif base_info.step == ArenaConst.champion_step.match_4 then
                if base_info.step_status == ArenaConst.champion_step_status.over then
                    tips_str = UI_TI18N(22071)
                else
                    tips_str = UI_TI18N(22072)
                end
            end
            StringUtil.gw_setLabelContent(item.count_info_label2, tips_str, 250)


            local data = ArenaController:getInstance():getChampionModel():getRoleInfo()
            if data == nil then
                StringUtil.gw_setLabelContent(item.rank_info_label2, UI_TI18N(22063), 220)
            else
                local tips_str = ""
                local rank = data.rank or 0
                if rank == 0 then
                    tips_str = UI_TI18N(22017)
                else
                    tips_str = rank
                end
                StringUtil.gw_setLabelContent(item.rank_info_label2, tips_str, 250)
            end

            local less_time = base_info.step_status_time - GameNet:getInstance():getTime()
            if less_time < 0 then
                less_time = 0
            end
            StringUtil.gw_setLabelContent(item.time_info_opened_label2, TimeTool.GetTimeFormat(less_time), 160)
        end

        item.block_opened:setVisible(true)
        item.block_closed:setVisible(false)
        item.time_info_opened:setVisible(true)
        item.time_info_closed:setVisible(false)
    end

    if red_status == true and item.red_point_spine == nil then
        item.red_point_spine = PathTool.gw_createRedpointSpine()
        item.red_point:addChild(item.red_point_spine)
    end
    item.red_point:setVisible(red_status)
end
function GW_ArenaHallWindow:updateSheet1PanelItem3()
    if self.sheet_type == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
        return
    end
    local item = self.sheet1_panel_item_list[3]

    local is_open = false
    local red_status = false
    StringUtil.gw_setLabelContent(item.name, UI_TI18N(22073), 245)
    if is_open == false then
        StringUtil.gw_setLabelContent(item.time_info_closed_label2, UI_TI18N(22074), 160)
        item.rank_info_label2:setString(UI_TI18N(22075))
        item.count_info_label1:setString(UI_TI18N(22076))
        item.count_info_label2:setString("0")
        local width = item.count_info_label1:getContentSize().width + item.count_info_label2:getContentSize().width + 5
        local scale = 1
        if width > 240 then
            scale = 240/width
            width = 240
        end
        item.count_info_label1:setPositionX(120 - (width*scale/2))
        item.count_info_label2:setPositionX(item.count_info_label1:getPositionX() + item.count_info_label1:getContentSize().width*scale + 5*scale)
        item.count_info_label1:setScale(scale)
        item.count_info_label2:setScale(scale)
        item.block_opened:setVisible(false)
        item.block_closed:setVisible(true)
        item.time_info_opened:setVisible(false)
        item.time_info_closed:setVisible(true)
    else
        item.block_opened:setVisible(true)
        item.block_closed:setVisible(false)
        item.time_info_opened:setVisible(true)
        item.time_info_closed:setVisible(false)
    end

    if red_status == true and item.red_point_spine == nil then
        item.red_point_spine = PathTool.gw_createRedpointSpine()
        item.red_point:addChild(item.red_point_spine)
    end
    item.red_point:setVisible(red_status)
end
function GW_ArenaHallWindow:handleEventSheet1Panel(status)
    if status == true then
        if self.sheet_type == nil or self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet1 then
            self:handleEventSheet1Panel(false)
            return
        end

        if self.sheet1_panel_time_ticket == nil then
            self.sheet1_panel_time_ticket = GlobalTimeTicket:getInstance():add(function()
                self:updateSheet1PanelItem1()
                self:updateSheet1PanelItem2()
            end, 1)
        end
        self:updateSheet1PanelItem1()
        self:updateSheet1PanelItem2()
    else
        if self.sheet1_panel_time_ticket ~= nil then
            GlobalTimeTicket:getInstance():remove(self.sheet1_panel_time_ticket)
            self.sheet1_panel_time_ticket = nil
        end
    end
end
function GW_ArenaHallWindow:countDownTimeTicketSheet1Panel()
    self:updateSheetPanels()

    local data = ArenaController:getInstance():getModel():getMyLoopData()
    if data == nil then
        self:handleEventSheet1Panel(false)
        return
    end
end
function GW_ArenaHallWindow:updateSheet2Panel()
    if self.sheet_type == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet2 then
        self.sheet2_panel:setVisible(false)
        return
    end


    self.sheet2_panel:setVisible(true)
end
function GW_ArenaHallWindow:updateSheet3Panel()
    if self.sheet_type == nil then return end
    if self.sheet_type ~= GW_ArenaHallConst.GW_Sheet_Type.Sheet3 then
        self.sheet3_panel:setVisible(false)
        return
    end


    self.sheet3_panel:setVisible(true)
end
--刷新页签1红点
function GW_ArenaHallWindow:updateSheet1Redpoint()
    if self.sheet_type == nil or self.sheet_btn_list == nil or self.sheet_btn_list[1] == nil then
        return
    end

    --竞技场
    local red_status = false
    if role_vo.lev >= Config.ArenaData.data_const["limit_lev"].val then
        red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_challenge)
        if red_status == false then
            red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_artivity)
        end
        if red_status == false then
            red_status = ArenaController:getInstance():getModel():getLoopMatchRedStatus(ArenaConst.red_type.loop_log)
        end

        --冠军赛红点
        if red_status == false then
            local base_info = ArenaController:getInstance():getChampionModel():getBaseInfo()
            local role_info = ArenaController:getInstance():getChampionModel():getRoleInfo()
            if base_info and role_info then
                --if base_info.round_status == ArenaConst.champion_round_status.guess then
                --    red_status = true
                --end
                if base_info.step == ArenaConst.champion_step.score then
                    if base_info.step_status ~= ArenaConst.champion_step_status.unopened then
                        red_status = true
                    end
                elseif base_info.step == ArenaConst.champion_step.match_32 then
                    if base_info.step_status == ArenaConst.champion_step_status.opened then
                        red_status = true
                    end
                elseif base_info.step == ArenaConst.champion_step.match_4 then
                    if base_info.step_status == ArenaConst.champion_step_status.opened then
                        red_status = true
                    end
                end
            end
        end
    end

    local item = self.sheet_btn_list[1]

    if red_status == true and item.red_point_spine == nil then
        item.red_point_spine = PathTool.gw_createRedpointSpine()
        item.red_point:addChild(item.red_point_spine)
    end
    item.red_point:setVisible(red_status)

end

