---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/9 10:43
---
GW_DramaMainlandIntroduceWindow = GW_DramaMainlandIntroduceWindow or BaseClass(BaseView)

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_DramaMainlandIntroduceWindow:__init()
    self.ctrl = GW_DramaMainlandIntroduceController:getInstance()
    self.is_full_screen = false
    self.layout_name = "gw_drama/gw_drama_mainland_introduce_window"
    self.win_type = WinType.Tips
    self.view_tag = ViewMgrTag.DIALOGUE_TAG

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_drama", "gw_drama_new"), type = ResourcesType.plist},
        { path = PathTool.getPlistImgForDownLoad("gw_drama","08_img_zhangjie", false), type = ResourcesType.single },
    }

end

function GW_DramaMainlandIntroduceWindow:openRootWnd(land_info)
    self.land_info = land_info

    self.name:setString(land_info.name)

    local res = PathTool.getPlistImgForDownLoad("gw_partnersummon/shipment_icons",land_info.tips_img,false)
    if self.icon_loader ~= nil then
        self.icon_loader:DeleteMe()
        self.icon_loader = nil
    end
    self.icon_loader = loadSpriteTextureFromCDN(self.icon, res, ResourcesType.single, self.icon_loader, nil, function(sender, event_type)
        if self.icon_loader ~= nil then
            self.icon_loader:DeleteMe()
            self.icon_loader = nil
        end
    end)


    if self.content_scroll_view_ticket == nil then
        self.content_scroll_view_ticket = GlobalTimeTicket:getInstance():add(function()
            if self.content_scroll_view == nil then
                self.content_scroll_view = createScrollView(self.content_container_size.width, self.content_container_size.height, 0, 0, self.content_container, ccui.ScrollViewDir.vertical)
                self.content_scroll_view:scrollToTop(0.1, false)
                --self.content_scroll_view:setScrollBarEnabled(true)
                --self.content_scroll_view:setScrollBarAutoHideEnabled(false)
                --self.content_scroll_view:setScrollBarWidth(4)
                --self.content_scroll_view:setScrollBarColor(cc.c3b(0xbc,0xbc,0xbc))
                --self.content_scroll_view:setScrollBarPositionFromCorner(cc.p(20,20))

                self.building_content = createRichLabel(30, cc.c4b(0x45,0x46,0x46,0xff), cc.p(0,1), cc.p(40,self.content_container_size.height - 20), nil, nil, 730)
                self.content_scroll_view:addChild(self.building_content)
            end

            self.building_content:setString(land_info.map_tips)
            local content_size = self.building_content:getSize()
            if content_size.height < self.content_container_size.height - 30 then
                content_size.height = self.content_container_size.height
            else
                content_size.height = content_size.height + 30
            end
            self.content_scroll_view:setInnerContainerSize(cc.size(self.content_container_size.width, content_size.height))
            self.building_content:setPositionY(content_size.height - 20)
            self.content_scroll_view:jumpToTop()

            if content_size.height > self.content_container_size.height then
                self.content_scroll_view:setTouchEnabled(true)
            else
                self.content_scroll_view:setTouchEnabled(false)
            end

            if self.content_scroll_view_ticket ~= nil then
                GlobalTimeTicket:getInstance():remove(self.content_scroll_view_ticket)
                self.content_scroll_view_ticket = nil
            end
        end,0.1)
    end
end

function GW_DramaMainlandIntroduceWindow:open_callback()
    if self.icon_loader ~= nil then
        self.icon_loader:DeleteMe()
        self.icon_loader = nil
    end
    --背景
    self.background = self.root_wnd:getChildByName("background")
    if self.background ~= nil then
        self.background:setScale(display.getMaxScale())
    end

    self.main_container = self.root_wnd:getChildByName("main_container")
    --引导需要
    if not GuideController:getInstance():isInGuide() then
        --播放窗口动画
        self:playEnterAnimatianByObj(self.main_container , 2)
    end

    self.bg = self.main_container:getChildByName("bg")
    local bg_res = PathTool.getPlistImgForDownLoad("gw_drama", "08_img_zhangjie", false)
    if not self.bg_load then
        self.bg_load = loadImageTextureFromCDN(self.bg, bg_res, ResourcesType.single, self.bg_load)
    end

    self.close_btn = self.main_container:getChildByName("close_btn")
    self.close_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            self:onClickCloseBtn()
        end
    end)
    self.name_bg = self.main_container:getChildByName("name_bg")
    self.name = self.main_container:getChildByName("name")
    self.icon = self.main_container:getChildByName("icon")
    self.content_container = self.main_container:getChildByName("content_container")
    self.content_container_size = self.content_container:getContentSize()

end

function GW_DramaMainlandIntroduceWindow:register_event()

end

function GW_DramaMainlandIntroduceWindow:close_callback()
    if self.background_load then
        self.background_load:DeleteMe()
        self.background_load = nil
    end

    if self.icon_loader ~= nil then
        self.icon_loader:DeleteMe()
        self.icon_loader = nil
    end

    if self.content_scroll_view_ticket ~= nil then
        GlobalTimeTicket:getInstance():remove(self.content_scroll_view_ticket)
        self.content_scroll_view_ticket = nil
    end

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_DramaMainlandIntroduceWindow:__delete()
    Debug.log("GW_DramaMainlandIntroduceWindow:__delete()")
end
--关闭
function GW_DramaMainlandIntroduceWindow:onClickCloseBtn(force)
    self.ctrl:closeView()
end