---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2021/7/9 16:20
---
GW_HookDropDetailWindow = GW_HookDropDetailWindow or BaseClass(BaseView)

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_HookDropDetailWindow:__init()
    self.ctrl = GW_HookDropDetailController:getInstance()
    self.is_full_screen = false
    self.layout_name = "gw_drama/gw_hook_drop_detail_window"
    self.win_type = WinType.Tips
    self.view_tag = ViewMgrTag.DIALOGUE_TAG

    self.res_list = {
        --{ path = PathTool.getPlistImgForDownLoad("gw_drama", "gw_drama"), type = ResourcesType.plist},
    }

end

function GW_HookDropDetailWindow:openRootWnd(land_id)

    self.land_id = land_id
    self:updateHookingInfo()
    self:updateBuildingList()
end

function GW_HookDropDetailWindow:open_callback()
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())

    self.container = self.root_wnd:getChildByName("main_container")

    self.container:getChildByName("title"):setString(UI_TI18N(14011))

    local list_container = self.container:getChildByName("list_container")

    self.preview_item_list = {}
    for i=1,4 do
        self.preview_item_list[i] = self.container:getChildByName("preview_item"..i)
        self.preview_item_list[i].icon = self.preview_item_list[i]:getChildByName("icon")
        self.preview_item_list[i].label1 = self.preview_item_list[i]:getChildByName("label1")
        self.preview_item_list[i].label2 = self.preview_item_list[i]:getChildByName("label2")
        self.preview_item_list[i].label2:setString(UI_TI18N(14002))
        self.preview_item_list[i].line = self.preview_item_list[i]:getChildByName("line")
    end

    self.close_btn = self.container:getChildByName("close_btn")

    self.list_container = list_container
    self.list_container_size = list_container:getContentSize()
    self.list_container:setScrollBarEnabled(false)

    self.list_container.cur_rewards = list_container:getChildByName("cur_rewards")
    self.list_container.cur_rewards:getChildByName("title_info"):getChildByName("label"):setString(UI_TI18N(14012))
    self.list_container.cur_rewards.item_container = self.list_container.cur_rewards:getChildByName("item_container")
    self.list_container.cur_rewards.list_cover = self.list_container.cur_rewards:getChildByName("list_cover")

    self.list_container.pre_rewards = list_container:getChildByName("pre_rewards")
    self.list_container.pre_rewards.list_bg = self.list_container.pre_rewards:getChildByName("list_bg")
    self.list_container.pre_rewards:getChildByName("title_info"):getChildByName("label"):setString(UI_TI18N(14013))


    --self.cur_info_node = self.container:getChildByName("cur_info_node")
    --self.per_hook_items_node = self.cur_info_node:getChildByName("per_hook_items_node")
    --self.reward_item_list_container = self.cur_info_node:getChildByName("reward_item_list_container")
    --self.reward_item_list_container_size = self.reward_item_list_container:getContentSize()
    --
    --self.list_container = self.container:getChildByName("list_container")
    --self.list_container_size = self.list_container:getContentSize()

    --引导需要
    if not GuideController:getInstance():isInGuide() then
        --播放窗口动画
        self:playEnterAnimatianByObj(self.container , 2)
    end
end

function GW_HookDropDetailWindow:register_event()
    registerButtonEventListener(self.close_btn, handler(self, self.onClickCloseBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

end

function GW_HookDropDetailWindow:close_callback()

    if self.list_container.cur_rewards.scroll_view then
        self.list_container.cur_rewards.scroll_view:DeleteMe()
        self.list_container.cur_rewards.scroll_view = nil
    end
    self.list_container.cur_rewards.reward_list = nil

    self.ctrl:closeView()
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_HookDropDetailWindow:__delete()
    Debug.log("GW_HookDropDetailWindow:__delete()")
end
--关闭
function GW_HookDropDetailWindow:onClickCloseBtn(force)
    self.ctrl:closeView()
end

--刷新当前收益
function GW_HookDropDetailWindow:updateHookingInfo()
    for i,v in pairs(self.preview_item_list) do
        v:setVisible(false)
    end

    self.list_container.cur_rewards.reward_list = nil
    self.list_container.cur_rewards.item_container:setVisible(false)
    self.list_container.cur_rewards.list_cover:setVisible(false)

    local hookData = BattleDramaController:getInstance():getModel():getHookAccumulateInfo()
    if hookData ~= nil then
        local hook_dun_id = hookData.hook_dun_id or 0
        if hook_dun_id > 0 then
            local drama_config = Config.DungeonData.data_drama_dungeon_info(hook_dun_id)
            if drama_config == nil then
                Debug.error(string_format("找不到挂机副本ID：%s", hook_dun_id))
                --return
                drama_config = Config.DungeonData.data_drama_dungeon_info(1010101)
            end

            for i, v in ipairs(drama_config.per_hook_items) do
                if i > #self.preview_item_list then
                    break
                end

                local item = self.preview_item_list[i]
                local config = Config.ItemData.data_get_data(v[1])
                loadSpriteTexture(item.icon, PathTool.getItemRes(config.icon, false), LOADTEXT_TYPE)
                item.label1:setString(v[2])
                item.label2:setPositionX(item.label1:getPositionX() + item.label1:getContentSize().width)
                item.line:setPositionX(item.label2:getPositionX() + item.label2:getContentSize().width + 20)
                item.total_with = item.line:getPositionX() + 16
                item.line:setVisible(false)

                if i > 1 then
                    local pre_item = self.preview_item_list[i-1]
                    pre_item.line:setVisible(true)
                    item:setPositionX(pre_item:getPositionX() + pre_item.total_with)
                end

                item:setVisible(true)
            end
        end

        --if hookData.list ~= nil and next(hookData.list) then
            self.list_container.cur_rewards.reward_list = {}
            local hooking_config = Config.DungeonData.data_drama_dungeon_info(hookData.hook_dun_id or 1010101)
            if hooking_config == nil then
                Debug.error("找不到副本ID:"..(hookData.hook_dun_id or 1010101))
                return
            end
            for i,v in pairs(hooking_config.hook_show_items) do
                table_insert(self.list_container.cur_rewards.reward_list, {bid = v[1], num = v[2]})
            end
            --self.list_container.cur_rewards.reward_list = deepCopy(hookData.list)
            if self.list_container.cur_rewards.scroll_view == nil then
                local scroll_view_size = self.list_container.cur_rewards.item_container:getContentSize()
                local list_setting = {
                    start_x = 11,
                    space_x = 21,
                    start_y = 0,
                    space_y = 11,
                    item_width = 130*0.8,
                    item_height = 130*0.8,
                    row = 2,
                    col = 0,
                    need_dynamic = true,
                    --checkovercallback = handler(self, self.updateSlideShowByVertical)
                }
                self.list_container.cur_rewards.scroll_view = CommonScrollViewSingleLayout.new(self.list_container.cur_rewards.item_container, cc.p(0, 0), ScrollViewDir.horizontal, ScrollViewStartPos.top, scroll_view_size, list_setting, cc.p(0, 0))

                self.list_container.cur_rewards.scroll_view:registerScriptHandlerSingle(handler(self,self.cur_rewards_createNewCell), ScrollViewFuncType.CreateNewCell) --创建cell
                self.list_container.cur_rewards.scroll_view:registerScriptHandlerSingle(handler(self,self.cur_rewards_numberOfCells), ScrollViewFuncType.NumberOfCells) --获取数量
                self.list_container.cur_rewards.scroll_view:registerScriptHandlerSingle(handler(self,self.cur_rewards_updateCellByIndex), ScrollViewFuncType.UpdateCellByIndex) --更新cell
                self.list_container.cur_rewards.scroll_view:registerScriptHandlerSingle(handler(self,self.cur_rewards_onCellTouched), ScrollViewFuncType.OnCellTouched) --更新cell
            end

            self.list_container.cur_rewards.scroll_view:reloadData()

            self.list_container.cur_rewards.item_container:setVisible(true)
            self.list_container.cur_rewards.list_cover:setVisible(#self.list_container.cur_rewards.reward_list > 6)
        --end

    end
end
--创建cell
--@width 是setting.item_width
--@height 是setting.item_height
function GW_HookDropDetailWindow:cur_rewards_createNewCell(width, height)
    local cell = GW_GoodsItem3.new(false, true, true, 0.8, true, true)
    cell:addCallBack(function() self:onCellTouched(cell) end)
    return cell
end
--获取数据数量
function GW_HookDropDetailWindow:cur_rewards_numberOfCells()
    if not self.list_container.cur_rewards.reward_list then return 0 end
    return #self.list_container.cur_rewards.reward_list
end
--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--index :数据的索引
function GW_HookDropDetailWindow:cur_rewards_updateCellByIndex(cell, index)
    cell.index = index
    local cell_data = self.list_container.cur_rewards.reward_list[index]
    if not cell_data then return end
    cell:setData(cell_data)
    local num = cell_data.num or 0
    if num > 0 then
        cell:setSelfNum(num)
    else
        cell:setSelfNum("")
    end
end
--点击cell .需要在 createNewCell 设置点击事件
function GW_HookDropDetailWindow:cur_rewards_onCellTouched(cell)

end

--刷新建筑列表
function GW_HookDropDetailWindow:updateBuildingList()

    --local pre_rewards_height = 0

    local building_configs = GW_DramaMainlandWindow.getLandBuildingConfigListByLandID(self.land_id)
    if building_configs ~= nil and next(building_configs) ~= nil then
        --pre_rewards_height = 74

        self.list_container.pre_rewards.reward_item_list_index = nil
        self.list_container.pre_rewards.reward_item_list_count = #building_configs

        self.list_container.pre_rewards.reward_item_list = {}
        for i,v in pairs(building_configs) do
            if self.list_container.pre_rewards.reward_item_list[i] == nil then
                local item = GW_HookDropDetailListItem.new()
                item.close_btn:addTouchEventListener(function(sender, event_type)
                    customClickAction(sender, event_type)
                    if event_type == ccui.TouchEventType.ended then
                        playButtonSound()
                        if self.list_container.pre_rewards.reward_item_list[i].data == nil or self.list_container.pre_rewards.reward_item_list[i].index == nil then return end
                        if self.list_container.pre_rewards.reward_item_list[i].open_flag == nil or self.list_container.pre_rewards.reward_item_list[i].open_flag == false then return end
                        local pre_open_index = self.list_container.pre_rewards.reward_item_list_index
                        self.list_container.pre_rewards.reward_item_list_index = nil
                        self:updateListContainerPosition(pre_open_index)
                    end
                end)
                item.open_btn:addTouchEventListener(function(sender, event_type)
                    customClickAction(sender, event_type)
                    if event_type == ccui.TouchEventType.ended then
                        playButtonSound()
                        if self.list_container.pre_rewards.reward_item_list[i].data == nil or self.list_container.pre_rewards.reward_item_list[i].index == nil then return end
                        if self.list_container.pre_rewards.reward_item_list[i].open_flag ~= nil and self.list_container.pre_rewards.reward_item_list[i].open_flag == true then return end
                        local pre_open_index = self.list_container.pre_rewards.reward_item_list_index
                        self.list_container.pre_rewards.reward_item_list_index = i
                        self:updateListContainerPosition(pre_open_index)
                    end
                end)
                self.list_container.pre_rewards:addChild(item)

                self.list_container.pre_rewards.reward_item_list[i] = item
            end

            local item = self.list_container.pre_rewards.reward_item_list[i]
            item:setData(i, v)
        end

        self.list_container.pre_rewards:setVisible(true)
    else
        self.list_container.pre_rewards.reward_item_list_index = nil
        self.list_container.pre_rewards.reward_item_list_count = 0
        self.list_container.pre_rewards:setVisible(false)
    end

    self:updateListContainerPosition()
    self.list_container:jumpToTop()

end

function GW_HookDropDetailWindow:updateListContainerPosition(pre_open_index)
    local height = 267
    if self.list_container.pre_rewards.reward_item_list_count > 0 then
        height = height + 74 + 96 * self.list_container.pre_rewards.reward_item_list_count
        if self.list_container.pre_rewards.reward_item_list_index ~= nil then
            height = height + 282
        end

        local pos_y = -74
        for i,v in pairs(self.list_container.pre_rewards.reward_item_list) do
            v:setPositionY(pos_y)

            if i==self.list_container.pre_rewards.reward_item_list_index then
                v:setOpen()
                pos_y = pos_y - 96 - 282
            else
                v:setClose()
                pos_y = pos_y - 96
            end

        end
    end

    local max_height = math.max(height, self.list_container_size.height)
    self.list_container.cur_rewards:setPositionY(max_height)
    self.list_container.pre_rewards:setPositionY(max_height - 267)

    local cur_inner_height = max_height - self.list_container_size.height
    local offset_y = 0
    if self.list_container.pre_rewards.reward_item_list_index ~= nil or pre_open_index ~= nil then
        local pos = self.list_container:getInnerContainerPosition()
        if pos.y > 0 then pos.y = 0 end
        local inner_size = self.list_container:getInnerContainerSize()
        local inner_height = inner_size.height - self.list_container_size.height
        offset_y = inner_height + pos.y

        if offset_y > cur_inner_height then
            offset_y = cur_inner_height
        end
    end


    self.list_container.pre_rewards.list_bg:setContentSize(cc.size(1188, max_height + 50))
    self.list_container:setInnerContainerSize(cc.size(self.list_container_size.width, max_height))
    self.list_container:setInnerContainerPosition(cc.p(0,offset_y - cur_inner_height))
end

-- --------------------------------------------------------------------
-- 建筑
-- --------------------------------------------------------------------
GW_HookDropDetailListItem = class("GW_HookDropDetailListItem", function()
    return ccui.Widget:create()
end)

function GW_HookDropDetailListItem:ctor()
    self:config()
    self:layoutUI()
    --self:registerEvents()

    self:setTouchEnabled(false)
end
function GW_HookDropDetailListItem:config()
    self.size = cc.size(1188,96)
    self:setContentSize(self.size)
    self:setAnchorPoint(cc.p(0,1))
end
function GW_HookDropDetailListItem:layoutUI()
    local csbPath = PathTool.getTargetCSB("gw_drama/gw_hook_drop_detail_list_item")
    self.root_wnd = cc.CSLoader:createNode(csbPath)
    self:addChild(self.root_wnd)

    local info = self.root_wnd:getChildByName("info")
    self.open_btn = info:getChildByName("open_btn")
    self.close_btn = info:getChildByName("close_btn")

    self.building_info = info:getChildByName("building_info")
    self.building_name = info:getChildByName("building_name")

    self.preview_bg = info:getChildByName("preview_bg")
    self.preview_item_list = {}
    for i=1,4 do
        self.preview_item_list[i] = info:getChildByName("preview_item"..i)
        self.preview_item_list[i].icon = self.preview_item_list[i]:getChildByName("icon")
        self.preview_item_list[i].label1 = self.preview_item_list[i]:getChildByName("label1")
        self.preview_item_list[i].label2 = self.preview_item_list[i]:getChildByName("label2")
        self.preview_item_list[i].label2:setString(UI_TI18N(14002))
        self.preview_item_list[i].line = self.preview_item_list[i]:getChildByName("line")
    end

    self.item_container = info:getChildByName("item_container")
    self.item_container_size = self.item_container:getContentSize()
    self.list_cover = info:getChildByName("list_cover")
end
--function GW_HookDropDetailListItem:registerEvents()
--    self.open_btn:addTouchEventListener(function(sender, event_type)
--        self:setOpen()
--
--        if self.refresh_callback then
--            self:refresh_callback(true, self.index, self.building_id)
--        end
--    end)
--    self.close_btn:addTouchEventListener(function(sender, event_type)
--        self:setClose()
--
--        if self.refresh_callback then
--            self:refresh_callback(false, self.index, self.building_id)
--        end
--    end)
--end
function GW_HookDropDetailListItem:DeleteMe()
    if self.scroll_view then
        self.scroll_view:DeleteMe()
        self.scroll_view = nil
    end

    self.reward_list = nil
end
function GW_HookDropDetailListItem:setData(index, building_config)
    self.reward_list = nil

    self.index = index
    self.data = building_config

    self.building_info:setString(building_config.building_number)
    self.building_name:setString(building_config.name)

    --self.drama_item_labels = self.drama_item_labels or {}
    --for i,v in ipairs(self.drama_item_labels) do
    --    v:setVisible(false)
    --end
    --
    --local drama_dun_ids = GW_DramaMainlandWindow.getBuildingDramaIDList(building_id)
    --local drama_dun_id = drama_dun_ids[1]
    --local drama_config = Config.DungeonData.data_drama_dungeon_info(drama_dun_id)
    --if drama_config == nil then
    --    message(string_format("找不到挂机副本ID：%s", drama_dun_id))
    --    --return
    --    drama_config = Config.DungeonData.data_drama_dungeon_info(1010101)
    --end
    --
    --self.drama_config = drama_config

    self:setClose()
end

function GW_HookDropDetailListItem:setOpen()
    self.open_flag = true

    if self.scroll_view == nil then
        local drama_dun_ids = GW_DramaMainlandWindow.getBuildingDramaIDList(self.data.id)
        local drama_dun_id = drama_dun_ids[1]
        local drama_config = Config.DungeonData.data_drama_dungeon_info(drama_dun_id)
        if drama_config ~= nil then
            if self.preview_item_list_count == nil and drama_config.per_hook_items ~= nil and next(drama_config.per_hook_items) ~= nil then
                local total_with = 0
                for i,v in pairs(drama_config.per_hook_items) do
                    if i > #self.preview_item_list then break end
                    self.preview_item_list_count = i

                    local item = self.preview_item_list[i]
                    local config = Config.ItemData.data_get_data(v[1])
                    loadSpriteTexture(item.icon, PathTool.getItemRes(config.icon, false), LOADTEXT_TYPE)
                    item.label1:setString(v[2])
                    item.label2:setPositionX(item.label1:getPositionX() + item.label1:getContentSize().width)
                    item.line:setPositionX(item.label2:getPositionX() + item.label2:getContentSize().width + 20)
                    item.total_with = item.line:getPositionX() + 16
                    item.line:setVisible(false)
                    if i > 1 then
                        local pre_item = self.preview_item_list[i-1]
                        pre_item.line:setVisible(true)
                    end

                    total_with = total_with + item.total_with
                end

                local pos_x = 1162 - total_with - 33
                for i=1,self.preview_item_list_count do
                    self.preview_item_list[i]:setPositionX(pos_x)

                    pos_x = pos_x + self.preview_item_list[i].total_with
                end
            end

            if drama_config.hook_show_items ~= nil and next(drama_config.hook_show_items) ~= nil then
                self.reward_list = {}
                for i,v in pairs(drama_config.hook_show_items) do
                    table_insert(self.reward_list, {id = v[1], num = v[2]})
                end
                local scroll_view_size = self.item_container_size
                local list_setting = {
                    start_x = 11,
                    space_x = 21,
                    start_y = 0,
                    space_y = 11,
                    item_width = 130*0.8,
                    item_height = 130*0.8,
                    row = 2,
                    col = 0,
                    container_width = self.item_container_size.width,
                    container_height = self.item_container_size.height,
                    need_dynamic = true,
                    --checkovercallback = handler(self, self.updateSlideShowByVertical)
                }
                self.scroll_view = CommonScrollViewSingleLayout.new(self.item_container, cc.p(0, 0), ScrollViewDir.horizontal, ScrollViewStartPos.top, scroll_view_size, list_setting, cc.p(0, 0))

                self.scroll_view:registerScriptHandlerSingle(handler(self,self.createNewCell), ScrollViewFuncType.CreateNewCell) --创建cell
                self.scroll_view:registerScriptHandlerSingle(handler(self,self.numberOfCells), ScrollViewFuncType.NumberOfCells) --获取数量
                self.scroll_view:registerScriptHandlerSingle(handler(self,self.updateCellByIndex), ScrollViewFuncType.UpdateCellByIndex) --更新cell
                self.scroll_view:registerScriptHandlerSingle(handler(self,self.onCellTouched), ScrollViewFuncType.OnCellTouched) --更新cell

                self.scroll_view:reloadData()
            end

        else
            Debug.error("找不到剧情副本配置！！副本ID："..drama_dun_id)
        end
    end

    if self.preview_item_list_count ~= nil then
        for i=1, self.preview_item_list_count do
            if i > #self.preview_item_list then
                break
            end

            self.preview_item_list[i]:setVisible(true)
        end
    end

    self.open_btn:setVisible(false)
    self.close_btn:setVisible(true)
    self.preview_bg:setVisible(self.preview_item_list_count ~= nil)
    self.item_container:setVisible(self.reward_list ~= nil)
    self.list_cover:setVisible(self.reward_list ~= nil)
end
--创建cell
--@width 是setting.item_width
--@height 是setting.item_height
function GW_HookDropDetailListItem:createNewCell(width, height)
    local cell = GW_GoodsItem3.new(false, true, true, 0.8, true, true)
    cell:addCallBack(function() self:onCellTouched(cell) end)
    return cell
end
--获取数据数量
function GW_HookDropDetailListItem:numberOfCells()
    if not self.reward_list then return 0 end
    return #self.reward_list
end
--更新cell(拖动的时候.刷新数据时候会执行次方法)
--cell :createNewCell的返回的对象
--index :数据的索引
function GW_HookDropDetailListItem:updateCellByIndex(cell, index)
    cell.index = index
    local cell_data = self.reward_list[index]
    if not cell_data then return end
    cell:setData(cell_data)
    local num = cell_data.num or 0
    if num > 1 then
        cell:setSelfNum(num)
    else
        cell:setSelfNum("")
    end
end
--点击cell .需要在 createNewCell 设置点击事件
function GW_HookDropDetailListItem:onCellTouched(cell)

end

function GW_HookDropDetailListItem:setClose()
    self.open_flag = false

    for i,v in pairs(self.preview_item_list) do
        v:setVisible(false)
    end
    self.preview_bg:setVisible(false)
    self.open_btn:setVisible(true)
    self.close_btn:setVisible(false)
    self.item_container:setVisible(false)
    self.list_cover:setVisible(false)
end

function GW_HookDropDetailListItem:addCallBack(callback)
    self.refresh_callback = callback
end
