-- --------------------------------------------------------------------
-- 星命塔的胜利战斗结算
-- 
-- @author: cloud@syg.com(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      这里填写详细说明,主要填写该模块的功能简要
-- <br/>Create: 2018-xx-xx
-- --------------------------------------------------------------------

StarTowerResultWindow = StarTowerResultWindow or BaseClass(BaseView)


function StarTowerResultWindow:__init(result, fight_type)
	self.result = result
	self.x = 100
	self.role_vo = RoleController:getInstance():getRoleVo()
	self.fight_type = fight_type
	self.is_running = true
	self.partner_list = {}
	self.item_list = {}
	self.dungeon_data = data
	self.cur_round = round
	self.total_round = total_round
	self.is_stop = false
	self.is_open_box = false
	self.win_type = WinType.Tips
	self.layout_name = "startower/gw_star_tower_result_win_window"
	self.view_tag = ViewMgrTag.DIALOGUE_TAG
	self.is_full_screen = false
	self.effect_list = {}
	self.res_list = {
		{ path = PathTool.getPlistImgForDownLoad("gw_battle_result", "gw_battle_result"), type = ResourcesType.plist },
		{ path = PathTool.getPlistImgForDownLoad("gw_battle_result", "01_bg", false), type = ResourcesType.single}
	}
	self.star = 0
	self.is_guide = GuideController:getInstance():isExistNextGuide()
end

function StarTowerResultWindow:openRootWnd(data,fight_type,battle_extend_data)
	--self:setData(data, fight_type, battle_extend_data)
	self.data = data
	self.fight_type = fight_type

	for i,v in pairs(self.data.hurt_statistics) do
		if v.type == 1 then
			local total_hurt = 0
			local max_hurt = 0
			local max_hurt_index = 1

			for j,w in pairs(v.partner_hurts) do
				total_hurt = total_hurt + w.dps
				if w.dps > max_hurt then
					max_hurt = w.dps
					max_hurt_index = j
				end
			end

			if total_hurt > 0 then
				self.total_hurt1:setString(max_hurt)
				self.total_hurt2:setString(string.format("(%0.2f", 100*max_hurt/total_hurt).."%)")
				self.total_hurt2:setPositionX(self.total_hurt1:getPositionX() + self.total_hurt1:getContentSize().width)
				self.total_hurt2:setVisible(true)
			else
				self.total_hurt1:setString(max_hurt)
				self.total_hurt2:setVisible(false)
			end

			local base_config = Config.PartnerData.data_partner_base[v.partner_hurts[max_hurt_index].bid]

			local res = PathTool.getPlistImgForDownLoad("gw_partnersummon/shipment_icons",base_config.shipment_icon_id,false)
			if self.camp_type_totem_load then
				self.camp_type_totem_load:DeleteMe()
				self.camp_type_totem_load = nil
			end
			self.camp_type_totem_load = loadSpriteTextureFromCDN(self.camp_type_totem, res, ResourcesType.single, self.camp_type_totem_load)

			local res = PathTool.getPlistImgForDownLoad("herodraw/herodrawres", base_config.draw_res)
			if self.hero_draw_load then
				self.hero_draw_load:DeleteMe()
				self.hero_draw_load = nil
			end
			self.hero_draw_load = loadSpriteTextureFromCDN(self.hero_draw, res, ResourcesType.single, self.hero_draw_load, 0,function()
				self.hero_draw:setPositionX(base_config.draw_offset[1])
				self.hero_draw:setPositionY(base_config.draw_offset[2])
				self.draw_node:setScale(base_config.draw_scale/100)
			end)

			self.content:setString(base_config.shipment_desc)
			local max_height = self.content:getContentSize().height + 10
			if max_height < self.content_scrollview:getContentSize().height then
				max_height = self.content_scrollview:getContentSize().height
			end
			self.content:setPositionY(max_height - 5)
			self.content_scrollview:setInnerContainerSize(cc.size(self.content_scrollview:getContentSize().width, max_height))
			self.content_scrollview:jumpToTop()
			break
		end
	end

	local role_vo = RoleController:getInstance():getRoleVo()
	self.role_head_info_lev:setString(role_vo.lev)
	self.role_role_head:setHeadRes(role_vo.face_id, false, LOADTEXT_TYPE, role_vo.face_file, role_vo.face_update_time)

	self.reward_item_list = self.reward_item_list or {}
	for i,v in pairs(self.reward_item_list) do
		v:setVisible(false)
	end

	local item_list ={}
	local asset_list = {}
	local first_award = self.data.first_award or {}
	for i, v in ipairs(first_award) do
		v.is_first = true
		table.insert(item_list,v)
	end
	for i, v in ipairs(self.data.award) do
		v.is_first = false
		table.insert(item_list,v)
	end
	local item_count = 0
	if item_list ~= nil and next(item_list) ~= nil then
		for i,v in pairs(item_list) do
			local item = self.reward_item_list[i]
			if item == nil then
				item = GW_GoodsItem3.new(false, true, false, 0.9, true, true)
				item:setDefaultTip()
				item:setPosition(cc.p(72+128*(i-1),70))
				self.reward_container:addChild(item)
				self.reward_item_list[i] = item
			end

			item:setBaseData(v.item_id, v.num)
			if v.is_first  and v.is_first ==true then
				item:gw_showFirstRewardFlag(true)--,UI_TI18N(33022))
			else
				item:gw_showFirstRewardFlag(false)
			end
			item:setVisible(true)

			item_count = item_count + 1
		end
	end
	--self.reward_container:setTouchEnabled(item_count > 5)
	local item_len = 72*2 + 128*(item_count-1)
	local container_size = self.reward_container:getContentSize()
	local max_width = math.max(container_size.width, item_len)
	self.reward_container:setInnerContainerSize(cc.size(max_width, container_size.height))
	self.reward_container:jumpToLeft()


	local pass_time = data.timer or 0
	if data.is_skip and data.is_skip == 1 then
		self.pass_time:setString(UI_TI18N(33023))
		self.harm_btn:setVisible(false)
		self.replay_btn:setVisible(false)
		self.total_hurt1:setString("")
		self.total_hurt2:setString("")
	else
		self.pass_time:setString(string.format("%s",TimeTool.GetTimeFormat(pass_time)))
		self.harm_btn:setVisible(true)
		self.replay_btn:setVisible(true)
	end
	self.pass_time:setFontSize(28)
	if self.pass_time:getContentSize().width > 610 then
		for i=1,10 do
			self.pass_time:setFontSize(28-i)
			if self.pass_time:getContentSize().width <= 610 then
				break
			end
		end
	end
	--新手引导不显示伤害和回放
	if self.is_guide then
		self.harm_btn:setVisible(false)
		self.replay_btn:setVisible(false)
	else
		self.harm_btn:setVisible(true)
		self.replay_btn:setVisible(true)
	end
end

--初始化
function StarTowerResultWindow:open_callback()
	playOtherSound("b_win", AudioManager.AUDIO_TYPE.BATTLE)

	self.left_top_infos = self.root_wnd:getChildByName("left_top_infos")
	--self.left_top_infos:setPositionX(display.getLeft())
	--self.left_top_infos:setPositionY(display.getTop())
	self.left_center_infos = self.root_wnd:getChildByName("left_center_infos")
	self.left_bottom_infos = self.root_wnd:getChildByName("left_bottom_infos")
	self.left_bottom_infos:setPositionX(display.getLeft())
	self.left_bottom_infos:setPositionY(display.getBottom())
	self.right_bottom_infos = self.root_wnd:getChildByName("right_bottom_infos")
	self.right_bottom_infos:setPositionX(display.getRight())
	self.right_bottom_infos:setPositionY(display.getBottom())
	self.right_top_infos = self.root_wnd:getChildByName("right_top_infos")
	self.right_top_infos:setPositionX(display.getRight())
	self.right_top_infos:setPositionY(display.getTop())

	--背景
	self.background = self.root_wnd:getChildByName("background")
	self.background:setScale(display.getMaxScale())
	local bg_res = PathTool.getPlistImgForDownLoad("gw_battle_result", "01_bg", false)
	if not self.background_load then
		self.background_load = loadImageTextureFromCDN(self.background, bg_res, ResourcesType.single, self.background_load)
	end

	self.camp_type_totem = self.left_top_infos:getChildByName("camp_type_totem")
	self.draw_node = self.left_center_infos:getChildByName("draw_node")
	self.hero_draw = self.draw_node:getChildByName("hero_draw")

	self.left_bottom_infos:getChildByName("mvp_title"):getChildByName("label"):setString(UI_TI18N(33014))
	self.left_bottom_infos:getChildByName("total_hurt_title"):getChildByName("label"):setString(UI_TI18N(33015))
	self.total_hurt1 = self.left_bottom_infos:getChildByName("total_hurt"):getChildByName("label1")
	self.total_hurt2 = self.left_bottom_infos:getChildByName("total_hurt"):getChildByName("label2")
	self.content_scrollview = self.left_bottom_infos:getChildByName("content"):getChildByName("scrollview")
	self.content_scrollview:setScrollBarEnabled(false)
	self.content = createRichLabel(20, cc.c4b(0xff,0xff,0xff,0xff), cc.p(0, 1), cc.p(10, 0), -2, nil, 404)
	self.content_scrollview:addChild(self.content)
	self.right_bottom_infos:getChildByName("title_infos"):getChildByName("label"):setString(UI_TI18N(33016))
	self.right_bottom_infos:getChildByName("title_infos"):getChildByName("title_bg"):getChildByName("label"):setString(UI_TI18N(33024))
	self.ok_btn = self.right_bottom_infos:getChildByName("ok_btn")
	self.ok_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()

			--新手引导直接回主城
			if self.is_guide then
				BattleController:getInstance():openBattleView(false, 0)
				BackToHome()
				return
			end
			--local success = self.data.result or 0    -- 胜利或者失败
			--if success == 1 then
			--	BattleController:getInstance():openFinishView(false,BattleConst.Fight_Type.StarTower)
			--else
			--	BattleController:getInstance():openFailFinishView(false,BattleConst.Fight_Type.StarTower)
			--end

			if BattleController:getInstance():getModel():getBattleScene() and BattleController:getInstance():getIsSameBattleType(self.fight_type) then
				BaseView.closeViewAndTips()
				StartowerController:getInstance():openResultWindow(false)
				BattleController:getInstance():openBattleView(false, 0)
				MainuiController:requestOpenBattleRelevanceWindow(BattleConst.Fight_Type.StarTower)
			else
				StartowerController:getInstance():openResultWindow(false)
			end
		end
	end)
	self.ok_btn_label = self.ok_btn:getChildByName("label")
	self.ok_btn_label:setString(UI_TI18N(33017))
	self.ok_btn_label:setFontSize(30)
	if self.ok_btn_label:getContentSize().width > 240 then
		for i=1,10 do
			self.ok_btn_label:setFontSize(30-i)
			if self.ok_btn_label:getContentSize().width <= 240 then
				break
			end
		end
	end
	self.back_btn = self.right_bottom_infos:getChildByName("back_btn")
	self.back_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			playButtonSound2()

			--新手引导直接回主城
			if self.is_guide then
				BattleController:getInstance():openBattleView(false, 0)
				BackToHome()
				return
			end

			--local success = self.data.result or 0    -- 胜利或者失败
			--if success == 1 then
			--	BattleController:getInstance():openFinishView(false,BattleConst.Fight_Type.StarTower)
			--else
			--	BattleController:getInstance():openFailFinishView(false,BattleConst.Fight_Type.StarTower)
			--end

			StartowerController:getInstance():openResultWindow(false)
			BaseView.closeViewAndTips()
			BattleController:getInstance():openBattleView(false, 0)
			MainuiController:requestOpenBattleRelevanceWindow(BattleConst.Fight_Type.StarTower)
		end
	end)
	self.back_btn_label = self.back_btn:getChildByName("label")
	self.back_btn_label:setString(UI_TI18N(33018))
	self.back_btn_label:setFontSize(30)
	if self.back_btn_label:getContentSize().width > 240 then
		for i=1,10 do
			self.back_btn_label:setFontSize(30-i)
			if self.back_btn_label:getContentSize().width <= 240 then
				break
			end
		end
	end
	self.harm_btn = self.right_top_infos:getChildByName("harm_btn")
	self.harm_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.data.is_skip and self.data.is_skip == 1 then return end

			playButtonSound2()
			self:_onClickHarmBtn()
		end
	end)
	self.harm_btn:setVisible(false)
	self.harm_btn_label = self.harm_btn:getChildByName("label")
	self.harm_btn_label:setString(UI_TI18N(33019))
	self.harm_btn_label:setFontSize(28)
	if self.harm_btn_label:getContentSize().width > 150 then
		for i=1,10 do
			self.harm_btn_label:setFontSize(28-i)
			if self.harm_btn_label:getContentSize().width <= 150 then
				break
			end
		end
	end
	self.replay_btn = self.right_top_infos:getChildByName("replay_btn")
	self.replay_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			if self.data.is_skip and self.data.is_skip == 1 then return end
			playButtonSound2()
			StartowerController:getInstance():openResultWindow(false)
			--local success = self.data.result or 0    -- 胜利或者失败
			--if success == 1 then
			--	BattleController:getInstance():openFinishView(false,BattleConst.Fight_Type.StarTower)
			--else
			--	BattleController:getInstance():openFailFinishView(false,BattleConst.Fight_Type.StarTower)
			--end

			local replay_id = self.data.replay_id or self.data.vedio_id -- 录像id
			local role_vo = RoleController:getInstance():getRoleVo()
			BattleController:getInstance():csRecordBattle(replay_id, role_vo.srv_id)
		end
	end)
	self.replay_btn:setVisible(false)
	self.replay_btn_label = self.replay_btn:getChildByName("label")
	self.replay_btn_label:setString(UI_TI18N(33025))
	self.replay_btn_label:setFontSize(28)
	if self.replay_btn_label:getContentSize().width > 150 then
		for i=1,10 do
			self.replay_btn_label:setFontSize(28-i)
			if self.replay_btn_label:getContentSize().width <= 150 then
				break
			end
		end
	end
	self.home_btn = self.right_top_infos:getChildByName("home_btn")
	self.home_btn:addTouchEventListener(function(sender, event_type)
		customClickAction_4(sender, event_type)
		if event_type == ccui.TouchEventType.ended then
			BattleController:getInstance():openBattleView(false, 0)
			BackToHome()
		end
	end)
	self.other_infos = self.right_bottom_infos:getChildByName("other_infos")
	self.role_head = self.other_infos:getChildByName("role_head")
	self.role_head_info = self.role_head:getChildByName("head_info")
	self.role_head_info_lev = self.role_head_info:getChildByName("lev_bg"):getChildByName("lev_label")
	self.role_head_node = self.role_head_info:getChildByName("head_node")
	self.role_role_head = PlayerHead.new(PlayerHead.type.square, 0)
	self.role_role_head:setPosition(0, 0)
	self.role_role_head:setHeadLayerScale(1)
	self.role_head_node:addChild(self.role_role_head)
	self.pass_time_label = self.other_infos:getChildByName("pass_time_label")
	self.pass_time_label:setString(UI_TI18N(33026))
	self.pass_time = self.other_infos:getChildByName("pass_time")

	self.other_infos:getChildByName("reward_title"):setString(UI_TI18N(33020))
	self.reward_container = self.other_infos:getChildByName("reward_container")
	self.reward_container:setScrollBarEnabled(false)
	--local res = ""
	--playOtherSound("b_win", AudioManager.AUDIO_TYPE.BATTLE)
	--
	--self.background = self.root_wnd:getChildByName("background")
	--self.background:setScale(display.getMaxScale())
	--self.source_container = self.root_wnd:getChildByName("container")
	--self.Sprite_1 = self.source_container:getChildByName("Sprite_1")
	--if self.sprite_1_load == nil then
    --    local res = PathTool.getPlistImgForDownLoad("bigbg","bigbg_97")
    --    self.sprite_1_load = loadSpriteTextureFromCDN(self.Sprite_1, res, ResourcesType.single, self.sprite_1_load)
    --end
    --
    --self.Sprite_2 = self.source_container:getChildByName("Sprite_2")
    --if self.sprite_2_load == nil then
    --    local res = PathTool.getPlistImgForDownLoad("bigbg","bigbg_98")
    --    self.sprite_2_load = loadSpriteTextureFromCDN(self.Sprite_2, res, ResourcesType.single, self.sprite_2_load)
    --end
	--self.title_container = self.source_container:getChildByName("title_container")
	--self.title_width = self.title_container:getContentSize().width
	--self.title_height = self.title_container:getContentSize().height
	--self:handleEffect(true)
	--
	--self.time_label = createRichLabel(22, 1, cc.p(0.5, 0.5), cc.p(self.root_wnd:getContentSize().width / 2 + 5,420), nil, nil, 1000)
	--self.time_label:setString(TI18N("10秒后关闭"))
	--self.root_wnd:addChild(self.time_label)
	--
	--self.harm_btn = self.source_container:getChildByName("harm_btn")
	--self.harm_btn:setVisible(false)
	--self.harm_btn:getChildByName("harm_lab"):setString(TI18N("数据统计"))
	--
	--self.fight_text = createLabel(24, cc.c4b(0xff,0xee,0xac,0xff), nil, 360, 455, "",self.source_container, nil, cc.p(0.5,0.5))
	--
	--local result_get_bg = createSprite(PathTool.getResFrame("common", "common_90044"), 360,415, self.source_container, cc.p(0.5, 0.5))
	--result_get_bg:setScaleX(5)
	--self.pass_time = createRichLabel(24, 31, cc.p(0.5, 0.5), cc.p(360, 415), nil, nil, 1000)
	--self.pass_time:setString(TI18N("00:00:00"))
	--self.source_container:addChild(self.pass_time)
	--
	--self.gain_label = createRichLabel(22, 1, cc.p(0.5, 0.5), cc.p(360, 100), nil, nil, 1000)
	--self.source_container :addChild(self.gain_label)
	--
	--local label  = createRichLabel(22,31, cc.p(0.5, 0.5), cc.p(360,368), nil, nil, 1000)
	--label:setString(TI18N("获得物品"))
	--self.source_container:addChild(label)
	--local result_line_bg = createSprite(PathTool.getResFrame("common", "common_1094"), 320, 368, self.source_container, cc.p(0, 0.5))
	--result_line_bg:setScaleX(-1)
	--local result_line_bg_2 = createSprite(PathTool.getResFrame("common", "common_1094"), 400,368, self.source_container, cc.p(0, 0.5))
	--
	--self.scroll_view = createScrollView(SCREEN_WIDTH, 230, 0, 130, self.source_container, ccui.ScrollViewDir.vertical)
	--
	--self.comfirm_btn = createButton(self.root_wnd,TI18N("确定"), 620, 580, cc.size(162, 62), PathTool.getResFrame("common", "common_1017"), 24, Config.ColorData.data_color4[1])
	--self.comfirm_btn:setPosition(self.root_wnd:getContentSize().width / 2 - 170, 470)
	--self.comfirm_btn:enableOutline(Config.ColorData.data_color4[264], 2)
	--self.comfirm_btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
	--		StartowerController:getInstance():openResultWindow(false)
	--	end
	--end)
	--
	--self.cancel_btn = createButton(self.root_wnd,TI18N("挑战下一层"), 620, 580, cc.size(162, 62), PathTool.getResFrame("common", "common_1018"), 24, Config.ColorData.data_color4[1])
	--self.cancel_btn:setPosition(self.root_wnd:getContentSize().width / 2 + 170, 470)
	--self.cancel_btn:enableOutline(Config.ColorData.data_color4[263], 2)
	--self.cancel_btn:addTouchEventListener(function(sender, event_type)
	--	if event_type == ccui.TouchEventType.ended then
    --        --BattleResultReturnMgr:returnByFightType(self.fight_type) --先
    --        if not self.data then return end
    --        local tower = self.data.tower or 0
    --        StartowerController:getInstance():openResultWindow(false)   -- 胜利之后可以直接进入下一层继续挑战
    --        if self.isCanNext  then
	--            StartowerController:getInstance():sender11322(tower + 1)
	--            if self.data.count > 0 and  tower < Config.StarTowerData.data_tower_base_length then
	--            	message(TI18N("已进入下一层战斗"))
	--            end
	--        else
	--        	BattleResultReturnMgr:returnByFightType(self.fight_type) --先
	--        end
	--	end
	--end)
end

function StarTowerResultWindow:register_event()
	--registerButtonEventListener(self.harm_btn, handler(self, self._onClickHarmBtn), true)
end

function StarTowerResultWindow:_onClickHarmBtn(  )
	if self.data and next(self.data) ~= nil then
		local setting = {}
        setting.fight_type = self.fight_type
		BattleController:getInstance():openBattleHarmInfoView(true, self.data, setting)
	end
end

----剧情：{章节id,难度，副本id}
--function StarTowerResultWindow:setData(data, fight_type, dungeon_data)
--	if data then
--		self.data = data or {}
--		self.dungeon_data = dungeon_data
--        self.fight_type = fight_type
--        local pass_time = data.timer or 0
--		local item_list ={}
--		local asset_list = {}
--		local first_award = self.data.first_award or {}
--
--
--
--		for i, v in ipairs(first_award) do
--			v.is_first = true
--			table.insert(item_list,v)
--		end
--		for i, v in ipairs(self.data.award) do
--			v.is_first = false
--			table.insert(item_list,v)
--		end
--		local str = ""
--		if asset_list and next(asset_list or {}) ~= nil then
--			for i, v in pairs(asset_list) do
--				if Config.ItemData.data_get_data(v.item_id) then
--					local icon = Config.ItemData.data_get_data(v.item_id).icon
--					local str_ = string.format("<div><img src='%s' scale=0.4 /></div><div fontcolor=#ffffff fontsize=24>+%s            </div>", PathTool.getItemRes(icon), v.num)
--					str = str .. str_
--				end
--			end
--		end
--		if self.gain_label and not tolua.isnull(self.gain_label) then
--			self.gain_label:setString(str)
--		end
--		self.reward_list = item_list
--		self.result = self.data.result
--		self.is_guide = self.data.is_guide
--
--		if data.is_skip and data.is_skip == 1 then
--			self.pass_time:setString(TI18N("团长的实力过于强大~敌人落荒而逃~"))
--			self.harm_btn:setVisible(false)
--		else
--			self.pass_time:setString(string.format( TI18N("%s"),TimeTool.GetTimeFormat(pass_time)))
--			self.harm_btn:setVisible(true)
--		end
--		self.harm_btn:setVisible(false)
--
--		--self.source_container:runAction(cc.Sequence:create(cc.FadeTo:create(0.2,150),cc.CallFunc:create(function ()
--			self:rewardViewUI()
--		--end)))
--		if self.fight_text then
--			local name = Config.BattleBgData.data_fight_name[self.fight_type]
--			if name then
--	    		self.fight_text:setString(TI18N("当前战斗：")..name)
--	    	end
--		end
--
--		-- local back_limit_lv = Config.BattleBgData.data_back_limit[self.fight_type] or 0
--		-- if self.role_vo.lev >= back_limit_lv then
--			self.cancel_btn:setVisible(true)
--			self.comfirm_btn:setPositionX(self.root_wnd:getContentSize().width / 2 - 170)
--			if self.data.tower then
--				self.isCanNext = false
--				local config  = Config.StarTowerData.data_tower_const.quick_challenge
--				if config then
--					if self.data.tower < config.val - 1 then
--						self.isCanNext = false
--						--self.cancel_btn:setBtnLabel(TI18N("返回玩法"))
--						self.cancel_btn:setVisible(false)
--						self.comfirm_btn:setPositionX(self.root_wnd:getContentSize().width/2)
--					else
--						self.isCanNext = true
--						self.cancel_btn:setBtnLabel(TI18N("挑战下一层"))
--					end
--				end
--			end
--		-- else
--		-- 	self.cancel_btn:setVisible(false)
--		-- 	self.comfirm_btn:setPositionX(self.root_wnd:getContentSize().width/2)
--		-- end
--	end
--end
--
--function StarTowerResultWindow:handleEffect(status)
--	if status == false then
--		if self.play_effect then
--			self.play_effect:clearTracks()
--			self.play_effect:removeFromParent()
--			self.play_effect = nil
--		end
--	else
--        if not tolua.isnull(self.title_container) and self.play_effect == nil then
--			self.play_effect = createEffectSpine(Config.EffectData.data_effect_info[103], cc.p(self.title_width * 0.5, self.title_height * 0.5), cc.p(0.5, 0.5), false, PlayerAction.action_2)
--			self.title_container:addChild(self.play_effect, 1)
--		end
--	end
--end
--
--
----奖励界面
--function StarTowerResultWindow:rewardViewUI()
--	local sum = #self.reward_list
--	local col =4
--	-- 算出最多多少行
--	self.row = math.ceil(sum / col)
--	self.space = 30
--	local max_height = self.space + (self.space + BackPackItem.Height) * self.row
--	self.max_height = math.max(max_height, self.scroll_view:getContentSize().height)
--	self.scroll_view:setInnerContainerSize(cc.size(self.scroll_view:getContentSize().width, self.max_height))
--
--	if sum >= col then
--		sum = col
--	end
--	local total_width = sum * BackPackItem.Width + (sum - 1) * self.space
--	self.start_x = (self.scroll_view:getContentSize().width - total_width) * 0.5
--
--	-- 只有一行的话
--	if self.row == 1 then
--		self.start_y = self.max_height * 0.5
--	else
--		self.start_y = self.max_height - self.space - BackPackItem.Height * 0.5
--	end
--	for i, v in ipairs(self.reward_list) do
--		local item = BackPackItem.new(true,true)
--		item:setScale(1.3)
--		item:setBaseData(v.item_id,v.num)
--		if v.is_first  and v.is_first ==true then
--			item:showBiaoQian(true,TI18N("首通"))
--		end
--		local name  = Config.ItemData.data_get_data(v.item_id).name
--		item:setGoodsName(name,nil,nil,1)
--		local _x = self.start_x + BackPackItem.Width * 0.5 + ((i - 1) % col) * (BackPackItem.Width + self.space)
--		local _y = self.start_y - math.floor((i - 1) / col) * (BackPackItem.Height + self.space)
--		item:setPosition(cc.p(_x, _y))
--		self.scroll_view:addChild(item)
--		self.item_list[i] = item
--	end
--	self:ItemAciton()
--end
--
--function StarTowerResultWindow:ItemAciton()
--	if self.item_list and next(self.item_list or {}) ~= nil then
--		local show_num = 0
--		for i,v in pairs(self.item_list) do
--			if v then
--				delayRun(self.root_wnd,0.1 * (i - 1),function()
--					v:setVisible(true)
--					v:runAction(cc.Sequence:create(cc.ScaleTo:create(0.1,1),cc.CallFunc:create(function ()
--							show_num = show_num + 1
--							if show_num >= tableLen(self.item_list) then
--								self:updateTimer()
--							end
--					end)))
--				end)
--			end
--		end
--	else
--		self:updateTimer()
--	end
--end
--
--function StarTowerResultWindow:updateTimer()
--    local time = 10
--    local call_back = function()
--        time = time - 1
--        local new_time = math.ceil(time)
--		local str = new_time..TI18N("秒后关闭")
--		if self.time_label and not tolua.isnull(self.time_label) then
--			self.time_label:setString(str)
--		end
--        if new_time <= 0 then
--            StartowerController:getInstance():openResultWindow(false)
--            GlobalTimeTicket:getInstance():remove("close_result_reward")
--        end
--    end
--    GlobalTimeTicket:getInstance():add(call_back,1, 0, "close_result_reward")
--end

--清理
function StarTowerResultWindow:close_callback()

	if self.background_load then
		self.background_load:DeleteMe()
		self.background_load = nil
	end

	if self.camp_type_totem_load then
		self.camp_type_totem_load:DeleteMe()
		self.camp_type_totem_load = nil
	end
	if self.hero_draw_load then
		self.hero_draw_load:DeleteMe()
		self.hero_draw_load = nil
	end

	if self.reward_item_list then
		for i,v in pairs(self.reward_item_list) do
			v:DeleteMe()
		end

		self.reward_item_list = nil
	end
	--
	--if self.partner_list then
	--	for i,v in ipairs(self.partner_list) do
	--		if v then
	--			v:DeleteMe()
	--		end
	--	end
	--end
	--self.partner_list = {}
	--self.partner_list = nil
	----self:handleEffect(false)
	--
	--if self.sprite_1_load then
    --    self.sprite_1_load:DeleteMe()
    --    self.sprite_1_load = nil
    --end
	--
    --if self.sprite_2_load then
    --    self.sprite_2_load:DeleteMe()
    --    self.sprite_2_load = nil
	--end
	--if not MainuiController:getInstance():checkIsInDramaUIFight() then
	--	AudioManager:getInstance():playLastMusic()
	--end
	--if BattleController:getInstance():getModel():getBattleScene() then
	--	local data = {result = self.result ,combat_type = BattleConst.Fight_Type.StarTower}
	--	BattleController:getInstance():getModel():result(data)
	--end
	--
	--GlobalTimeTicket:getInstance():remove("close_result_reward")
	StartowerController:getInstance():openResultWindow(false)

	--星命塔战斗中不执行引导，引导通过胜利结算页面关闭发送执行引导事件
	GuideController:getInstance():setDramaBattleStates(false)
	GlobalEvent:getInstance():Fire(GuideConst.EVENT_PREPARE_PLAY_PLOT)
end
