---
--- Generated by EmmyLua(https://github.com/EmmyLua)
--- Created by gw.
--- DateTime: 2022/1/17 15:13
---
GW_SignWindow = GW_SignWindow or BaseClass(BaseView)

local string_format = string.format
local table_sort = table.sort
local table_insert = table.insert
local table_remove = table.remove

function GW_SignWindow:__init()
    self.ctrl = WelfareController:getInstance()
    self.model = self.ctrl:getModel()
    self.role_vo = RoleController:getInstance():getRoleVo()
    self.is_full_screen = false
    self.layout_name = "welfare/gw_sign_window"
    self.win_type = WinType.Big
    self.view_tag = ViewMgrTag.DIALOGUE_TAG

    self.res_list = {
        { path = PathTool.getPlistImgForDownLoad("gw_welfare", "gw_sign"), type = ResourcesType.plist},
    }

end

function GW_SignWindow:openRootWnd()
    self.ctrl:sender14100()
end

function GW_SignWindow:open_callback()
    --背景
    self.background = self.root_wnd:getChildByName("background")
    self.background:setScale(display.getMaxScale())

    self.main_container = self.root_wnd:getChildByName("main_container")
    --local title = self.main_container:getChildByName("title")
    --title:setString(UI_TI18N(24001))
    --title:setFontSize(52)
    --if title:getContentSize().width > 360 then
    --    for k=1,20 do
    --        title:setFontSize(52-k)
    --        if title:getContentSize().width <= 360 then
    --            break
    --        end
    --    end
    --end
    local tips_label = self.main_container:getChildByName("tips_label")
    tips_label:setString(UI_TI18N(24002))
    tips_label:setFontSize(26)
    if tips_label:getContentSize().width > 300 then
        for k=1,15 do
            tips_label:setFontSize(26-k)
            if tips_label:getContentSize().width <= 300 then
                break
            end
        end
    end
    self.close_btn = self.main_container:getChildByName("close_btn")

    self.tips_btn = self.main_container:getChildByName("tips_btn")
    self.tips_btn:addTouchEventListener(function(sender, event_type)
        customClickAction(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            playButtonSound2()
            TipsManager:getInstance():showCommonTips(Config.CheckinData.data_const.checkin_rules.desc,sender:getTouchBeganPosition())
        end
    end)

    self.list_container = self.main_container:getChildByName("list_container")

    --引导需要
    if not GuideController:getInstance():isInGuide() then
        --播放窗口动画
        self:playEnterAnimatianByObj(self.main_container , 2)
    end
end

function GW_SignWindow:register_event()
    registerButtonEventListener(self.close_btn, handler(self, self.onClickCloseBtn) ,true, REGISTER_BUTTON_SOUND_CLOSED_TYPY)

    if self.update_sign_info == nil then
        self.update_sign_info = GlobalEvent:getInstance():Bind(WelfareEvent.Update_Sign_Info,function ( data )
            self:createList(data)
        end)
    end

    if self.sign_success == nil then
        self.sign_success = GlobalEvent:getInstance():Bind(WelfareEvent.Sign_Success,function ( data )
            self:createList(data)
        end)
    end

    ---- 引导中不给滑动列表
    --if self.update_guide_status == nil then
    --    self.update_guide_status = GlobalEvent:getInstance():Bind(GuideEvent.Update_Guide_Status_Event,function ( in_guide )
    --        --if in_guide then
    --        --    self.item_scrollview:setClickEnabled(false)
    --        --else
    --        --    self.item_scrollview:setClickEnabled(true)
    --        --end
    --    end)
    --end
end

function GW_SignWindow:close_callback()
    if self.update_sign_info ~= nil then
        GlobalEvent:getInstance():UnBind(self.update_sign_info)
        self.update_sign_info = nil
    end

    if self.sign_success ~= nil then
        GlobalEvent:getInstance():UnBind(self.sign_success)
        self.sign_success = nil
    end

    --if self.update_guide_status ~= nil then
    --    GlobalEvent:getInstance():UnBind(self.update_guide_status)
    --    self.update_guide_status = nil
    --end

    if self.item_scrollview then
        self.item_scrollview:DeleteMe()
        self.item_scrollview = nil
    end

    self.ctrl:gw_openSignWindow(false)
end
--==============================--
--desc:移除ui这个操作只有在切换账号的时候触发
--time:2021-06-29 10:51:38
--@return
--==============================--
function GW_SignWindow:__delete()
    Debug.log("GW_SignWindow:__delete()")
end
--关闭
function GW_SignWindow:onClickCloseBtn(force)
    self.ctrl:gw_openSignWindow(false)
end

function GW_SignWindow:createList(data)
    if self.item_scrollview == nil then
        local scroll_view_size = self.list_container:getContentSize()
        local setting = {
            item_class = GW_SignItem,      -- 单元类
            start_x = 12,                  -- 第一个单元的X起点
            space_x = 7,                    -- x方向的间隔
            start_y = 12,                    -- 第一个单元的Y起点
            space_y = 3,                   -- y方向的间隔
            item_width = 108,               -- 单元的尺寸width
            item_height = 108,              -- 单元的尺寸height
            row = 0,                        -- 行数，作用于水平滚动类型
            col = 7                         -- 列数，作用于垂直滚动类型
        }

        self.item_scrollview = CommonScrollViewLayout.new(self.list_container, cc.p(0,0) , ScrollViewDir.vertical, ScrollViewStartPos.top, scroll_view_size, setting)

    end
    ---- 引导中不给滑动列表
    --if GuideController:getInstance():isInGuide() then
    --    self.item_scrollview:setClickEnabled(false)
    --end
    self.item_scrollview:setClickEnabled(false)

    local config = Config.CheckinData.data_award
    local now_time = GameNet:getInstance():getTime()
    local month = tonumber(os.date("%m", now_time))
    local data_list = deepCopy(config[month])

    local has_day = data.day
    local now_day = 0
    for k,v in pairs(data_list) do
        if data.status >0 then
            if k< has_day then --累计的
                v.status = 2 --已领取全部奖励
            elseif k == has_day then --今天
                v.status = data.status
                --v.now_day = k
            else--之后的
                v.status = 0 --没领
            end
            v.now_day = has_day
            now_day = has_day
        elseif data.status == 0 then
            if k<= has_day then --累计的
                v.status = 2 --已领取全部奖励
            elseif k == has_day+1 then --今天
                v.status = data.status
            else--之后的
                v.status = 0 --没领
            end
            v.now_day = has_day+1
            now_day = has_day+1
        end
    end
    --print("=====len==",month,#data_list)

    self.item_scrollview:setData(data_list,function ( cell )
        local data = cell:getData()
        --print("=====now_day====",data.now_day,data.day)
        if data.status == 1 and data.now_day == data.day and self.model:getRechargeCount()==0 then
            local str = UI_TI18N(24003)
            local function fun()
                VipController:getInstance():openVipMainWindow(true,VIPTABCONST.CHARGE)
                --MallController:getInstance():openChargeShopWindow(true, MallConst.Charge_Shop_Type.Diamond)
            end
            local function cancel_callback()
            end
            CommonAlert.show(str,UI_TI18N(13002),fun,UI_TI18N(13003),cancel_callback,CommonAlert.type.rich, cancel_callback)
        elseif data.day > data.now_day then
            message(UI_TI18N(24004))
        else
            self.ctrl:sender14101()
        end
    end)

    self.item_scrollview:addEndCallBack(function ()
        local list = self.item_scrollview:getItemList()
        local pos
        for k, v in pairs(list) do
            local vo = v:getData()
            if vo.day == 26 then
                pos = v:getItemPosition()
            end
        end
        if now_day >= 25 then
            self.item_scrollview:jumpToMove(cc.p(pos.x,pos.y+self.item_scrollview:getContentSize().height/2),0.1)
        end
    end)
end

-- --------------------------------------------------------------------
-- 签到子项
--
-- @author: shuwen(必填, 创建模块的人员)
-- @editor: xxx@syg.com(必填, 后续维护以及修改的人员)
-- @description:
--      这里填写详细说明,主要填写该模块的功能简要
-- <br/>Create: 2018-06-12
-- --------------------------------------------------------------------
GW_SignItem = class("GW_SignItem", function()
    return ccui.Widget:create()
end)


function GW_SignItem:ctor()
    self:configUI()
    self:register_event()
end

function GW_SignItem:configUI(  )
    self.root_wnd = createCSBNote(PathTool.getTargetCSB("welfare/gw_sign_window_item"))
    self:addChild(self.root_wnd)
    -- self:setCascadeOpacityEnabled(true)
    --self:setSwallowTouches(false)
    self:setContentSize(cc.size(108,108))
    self:setAnchorPoint(0,0)

    self.main_container = self.root_wnd:getChildByName("main_container")
    self.main_container:setSwallowTouches(false)

    self.can_get = self.main_container:getChildByName("can_get")
    --self.can_get:setLocalZOrder(20)
    self.can_get:setVisible(false)
    self.get = self.main_container:getChildByName("get")
    self.get:setLocalZOrder(20)
    self.get:setVisible(false)
    self.get2 = self.main_container:getChildByName("get2")
    self.get2:getChildByName("label"):setString(UI_TI18N(24005))
    --self.img = self.get2:getChildByName("img")
    --self.get2:setLocalZOrder(20)
    self.get2:setVisible(false)
    --doStopAllActions(self.img)

    local item_node = self.main_container:getChildByName("item_node")
    self.goods_item = GW_GoodsItem3.new(true,true)
    --self.goods_item:setData(Config.ItemData.data_get_data(1))
    self.goods_item:setScale(0.77)
    self.goods_item:setAnchorPoint(0.5,0.5)
    self.goods_item:setPosition(0,0)
    self.goods_item:setTouchEnabled(false)
    self.goods_item:setSwallowTouches(false)
    item_node:addChild(self.goods_item)
end

function GW_SignItem:register_event(  )
    self.main_container:addTouchEventListener(function(sender, event_type)
        if event_type == ccui.TouchEventType.ended then
            self.touch_end = sender:getTouchEndPosition()
            local is_click = true
            if self.touch_began ~= nil then
                is_click =
                math.abs(self.touch_end.x - self.touch_began.x) <= 20 and
                        math.abs(self.touch_end.y - self.touch_began.y) <= 20
            end
            if is_click == true then
                playButtonSound2()
                if self.callback then
                    self:callback()
                end
            end
        elseif event_type == ccui.TouchEventType.moved then
        elseif event_type == ccui.TouchEventType.began then
            self.touch_began = sender:getTouchBeganPosition()
        elseif event_type == ccui.TouchEventType.canceled then
        end
    end)
end

function GW_SignItem:setData( data )
    if data == nil then return end
    self.data = data

    -- 引导需要
    if data._index then
        self.main_container:setName("sign_btn_" .. data._index)
    end

    local vo = {}
    vo = deepCopy(Config.ItemData.data_get_data(data.rewards[1][1]))
    vo.quantity = data.rewards[1][2]
    self.goods_item:setData(vo)
    if data.status then
        if data.status == 0 then  --没领
            if data.now_day == data.day then--是今天
                self.can_get:setVisible(true)
            else
                self.can_get:setVisible(false)
            end
            --if data.now_day == data.day then --是今天
            --    if self.effect == nil then
            --        self.effect = createEffectSpine(PathTool.getEffectRes(262), cc.p(self.main_container:getContentSize().width/2,self.main_container:getContentSize().height/2), cc.p(0.5, 0.5), true, "action")
            --        self.effect:setScale(1)
            --        self.main_container:addChild(self.effect)
            --    end
            --    self.effect:setVisible(true)
            --else
            --    if self.effect then
            --        self.effect:setVisible(false)
            --    end
            --end
            self.main_container:setTouchEnabled(true)
            self.get2:setVisible(false)
            --doStopAllActions(self.img)
            self.get:setVisible(false)

        elseif data.status == 1 then --领取普通奖励
            --if self.effect then
            --    self.effect:setVisible(false)
            --end
            self.get2:setVisible(true)
            --breatheShineAction(self.img)
            self.get:setVisible(false)
            self.can_get:setVisible(false)
            self.main_container:setTouchEnabled(true)
        elseif data.status == 2 then --领取vip奖励
            --if self.effect then
            --    self.effect:setVisible(false)
            --end
            --doStopAllActions(self.img)
            self.get2:setVisible(false)
            self.get:setVisible(true)
            self.can_get:setVisible(false)
            self.main_container:setTouchEnabled(false)
        end
    end

    --if data.is_show then
    --    if data.is_show==1 then
    --        self.goods_item:showItemEffect(true,263,PlayerAction.action_2,true,1.1)
    --    else
    --        self.goods_item:showItemEffect(false)
    --    end
    --end
end

function GW_SignItem:addCallBack( value )
    self.callback =  value
end

function GW_SignItem:getData( )
    return self.data
end

function GW_SignItem:getItemPosition()
    if self then
        return cc.p(self:getPosition())
    end
end


function GW_SignItem:DeleteMe()
    --doStopAllActions(self.img)
    if self.goods_item then
        self.goods_item:DeleteMe()
    end
    self:removeAllChildren()
    self:removeFromParent()
end